; ********************************************
; **** RunRepts                           ****
; ****                                    ****
; ****                                    ****
; ****                                    ****
; ****                                    ****
; ****Written by:G.Salcedo                ****
; ****Date:                               ****
; ********************************************
;
; Runs a report for any table in the current directory
; if the report number is not valid, it runs the standard report
;

While (true)


ShowTables
         directory()
         "Select a table and press [ENTER]"
         to tablename

if tablename = "Esc" then
     quitloop
endif
if tablename = "None" then
     @24,0 Clear EOL ?? "No tables in the directory" style blink ?? "..." style
     beep
     sleep 1000
     quitloop
endif


@24,0 Clear EOL ?? format("AR,W50","Continue and run report for table..."),tablename," "
Style blink
accept "A1" required picture "{Y,N}" default "Y" to answer
style
if isassigned(answer) = false then
     quitloop
endif
if answer = "N" then
     quitloop
endif

testrepno = tablename+"."+repno

if isfile(testrepno) = false then
     repno = "R"
endif



While (true)
        ShowMenu
                "Printer": "Send Report to the Printer",
                "Screen" : "Send Report to the screen",
                "Quit"   : "Don't run the Report"

                default "Printer" to sel

       Switch

       case sel = "Printer" :
        if printerstatus() = false then
             CURSOR OFF
             STYLE ATTRIBUTE (MENUCOLOR+128)
             @24,0 Clear EOL ?? format("AC,W80","PRINTER NOT READY ...")
             style ATTRIBUTE MENUCOLOR
             CURSOR NORMAL
             loop
        endif

        STYLE ATTRIBUTE (MENUCOLOR+128)

        @24,0 Clear EOL ?? format("AC,W79","PRINTING REPORT")

        REPORT tablename repno

       @24,0 Clear EOL

       case sel = "Screen": Menu {Report}{OutPut} select tablename
                            select repno select sel
                            CURSOR OFF
                            style attribute menucolor+128
                            @24,0 Clear EOL ?? format("AC,W80","ONE MOMENT")
                            style attribute menucolor
                            CURSOR NORMAL
       case sel = "Quit"  : quitloop

       OtherWise:beep

       EndSwitch
quitloop
EndWhile



quitloop
EndWhile
