; EntrData

CLEAR
CURSOR OFF                                       ;  Place informational message
MESSAGE "Loading form, Please wait"              ; on the screen while form is
CANVAS OFF                                       ; loading
IF ISEMPTY("Employee") THEN                      ;  If the table is empty, set
  empid = 1001                                   ; the id counter to 1001
ELSE                                             ; otherwise calculate the max
  empid = CMAX("Employee","Employee ID") + 1     ; id in the table and add 1.
ENDIF                                            ; This is used to set Employee
MENU {Modify} {DataEntry} {Employee}             ; ID.
{Image} {Pickform} {1}
[Employee ID] = empid
empid = empid + 1
CANVAS ON                                        ;  Need to turn canvas on!
WHILE True
  WAIT RECORD
    PROMPT "Enter New Employee Information    [F2]-Save/Exit    [Esc]-Cancel",
           "[F3]-Employee Data    [F4]-Benefits Data     " +
           "[F5]-Dependents Data"
    UNTIL "F2","F3","F4","F5","Esc","PgDn","PgUp","End","Home"
  tblname = TABLE()
  SWITCH
    CASE retval = "F2" :
         CLEAR
         MESSAGE "Saving data, Please wait"
         CANVAS OFF
         DO_IT!                                 ;  NOTE: need to check for
         QUITLOOP                               ; key violations in Depndnts
    CASE retval = "F3" : MOVETO "Entry"  LOOP   ;  Moveto Employee Table
    CASE retval = "F4" : MOVETO "Entry1" LOOP   ;  Moveto Benefits Table
    CASE retval = "F5" : MOVETO "Entry2" LOOP   ;  Moveto Depndnts Table
    CASE retval = "Esc" :
         SHOWMENU
           "No"  : "Return to Data Entry",
           "Yes" : "Cancel data entry"
         TO canceloption
         IF canceloption = "Yes" THEN
           CLEAR
           MESSAGE "Data Entry cancelled"
           CANVAS OFF
           CANCELEDIT
           QUITLOOP
         ENDIF
      CASE retval = "PgDn" :
           SWITCH
             CASE tblname = "Entry" :
                  PgDn                             ;  Moveto next Employee rcd
                  IF ISBLANK([Employee ID]) THEN   ;  If this is a new record
                    [Employee ID] = empid          ; set the Employee ID
                    empid = empid + 1
                  ENDIF
             CASE tblname = "Entry1" :             ;  Only 1 record allowed for
                  BEEP LOOP                        ; Benefits table
             CASE tblname = "Entry2" :             ;  Moveto next record in
                  DOWN CtrlHome                    ; Depndnts table
           ENDSWITCH
           LOOP
      CASE retval = "PgUp" :
           IF ATFIRST() THEN
             BEEP
             LOOP
           ENDIF
           IF tblname = "Entry1" THEN              ;  Only 1 record allowed for
             BEEP                                  ; Benefits table
           ELSE                                    ;  For Employee and Depndnts
             SKIP -1                               ; move to the previous
           ENDIF                                   ; record
           LOOP
    OTHERWISE:
         KEYPRESS retval
  ENDSWITCH
ENDWHILE
CLEARALL
