;MAINMENU.SC (FIRST ROUTINE FOR POP-UP MENUS)
;
;Script [MainMenu] Type [FirstMenu]  Called from [   ]
;
;Description [This is the main Menu for a system]
;
;
;Created [07/31/90] By [G.Salcedo ]
;

setkey "F11" play "MainMenu"

While (true)
CANVAS OFF
Release Procs All
Release Vars All
Reset
Clear
ClearAll
Autolib = "Menus,MesgLibr,MenuHelp"

Array  Prevx[10]
Array  Prevy[10]
Array PrevNC[10]
Array PrevPW[10]
Array PrevCL[10]
Array  PrevN[10]
Array PrevML[10]

Level = 1
    n = 1

 Prevx[Level] = 3
 Prevy[Level] = 25
PrevNC[Level] = 5
PrevPW[Level] = 20
PrevCL[Level] = 31
PrevML[Level] = format("W18,AC","Main Menu")

       BeginX = Prevx[Level]
       BeginY = Prevy[Level]
NumberChoices = PrevNC[Level]
     Popwidth = PrevPW[Level]
        Color = PrevCL[level]
     MenuName = PrevML[level]



;
;You must declare the following:
;
;        C[n] = menu items (the possible choices)
;        D[n] = descriptions of the menu items
;       SC[n] = "top bar" representation of menu item
;       SD[n] = "top bar" description
;     NICK[n] = first letter of menu items


Array         C[NumberChoices]
Array         D[NumberChoices]
Array        SC[NumberChoices]
Array        SD[NumberChoices]
Array      NICK[NumberChoices]






C[1] = "View/Modify"
D[1] = "Go to the MODIFY menu"


C[2] = "Reports"
D[2] = "Go the Report Menu"


C[3] = "Utilities"
D[3] = "Go to the Utilities Menu"


C[4] = "Info"
D[4] = "More information on system"


C[5] = "Quit"
D[5] = "Exit the System"



if isassigned(n) = false then
     n = 1
else
     n = n
endif

last = arraysize(c)






CANVAS ON
FillMenu()

SelMenu()
Reset

if sel = "Esc" then
     @24,0 Clear EOL ?? format("w79,ac","One moment please ...")
     quitloop

else


switch
           case sel = "Esc" : level = level -1
                              quitloop
           case sel = c[1]  : play "nextmenu"  ;example of nested menus
           case sel = c[2]  : "";play "reptmenu"
           case sel = c[3]  : "";play "utilmenu"
           case sel = c[4]  : HelpMenu(sel)
           case sel = c[5]  : quitloop

EndSwitch
endif

EndWhile
