;
;Script [MenuHelp] Type [Help    ] Called from [Menus  ]
;
;Description [Provides Help for all Menu Choices]
;
;
;Created [04/12/90] By [G.Salcedo ]
;

  @24,0 Clear EOL ?? "Compiling MenuHelp "
  Style Blink ?? "..."
  Style

  createlib "MenuHelp"

  Proc Closed HelpMenu(Sel)
  Usevars Color
  Private TR,LC,BR,RC

  CANVAS OFF
  CURSOR OFF

  TR = 19
  LC = 10
  BR = 22
  RC = 66

  PaintCanvas Attribute Color
  TR,LC,BR,RC


  PAINTCANVAS Fill "" Attribute 113
  TR+1,LC+2,TR+4,RC+2


                     ;....+...10....+...20....+....30....+...40....+...50....+.
  if sel = "View" then
           HLine1  = "SELECT View to browse thru tables and to perform minor"
           HLine2  = "editing.  SUGGESTION: for MAJOR editing SELECT EDIT"
           HLine3  = ""
  endif
  if sel = "View/Modify" then
           HLine1  = "This choice allows you to go the View/Modify Menu"
           HLine2  = "You may View or Edit any file in the current"
           HLine3  = "directory."
  endif
  if sel = "Choice #1" then
           HLine1  = "                                   "
           HLine2  = "                                   "
           HLine3  = "                                   "
  endif
  if sel = "Reports" then
           HLine1  = ""
           HLine2  = "              Go to the REPORTS Menu"
           HLine3  = ""
  endif

  if sel = "Utilities" then
           HLine1  = "BACKUP, Recovery, System Utilities "
           HLine2  = "RUN OTHER PROGRAMS                 "
           HLine3  = "EXPORT/IMPORT data                 "
  endif
  if sel = "Info" then
           HLine1  = "This is where GENERAL INFORMATION about the system is   "
           HLine2  = "placed.  [F1] will bring up context sensitive HELP for  "
           HLine3  = "a menu choice if it is available."
  endif
  if sel = "Edit" then
           HLine1  = "Choose this function to perform MAJOR editing"
           HLine2  = ""
           HLine3  = ""
  endif
  if sel = "DataEntry"     then
           HLine1  = "Allows you to perform initial and batch entries of"
           HLine2  = "data.          "
           HLine3  = "                       "
  endif
  if sel = "Choice #2" then
           HLine1  = "                       "
           HLine2  = "                       "
           HLine3  = "                       "
  endif
  if sel = "Choice #3" then
           HLine1  = "                                   "
           HLine2  = "                                   "
           HLine3  = "                                   "
  endif
  if sel = "Choice #4" then
           HLine1  = "                                   "
           HLine2  = "                                   "
           HLine3  = "                                   "
  endif
  if sel = "More" then
           HLine1  = ""
           HLine2  = "    More SELECTIONS"
           HLine3  = ""
  endif
  if sel = "Next Choice 1" then
           HLine1  = ""
           HLine2  = "                No Help Available"
           HLine3  = ""
  endif
  if sel = "Next Choice 2" then
           HLine1  = ""
           HLine2  = "                No Help Available"
           HLine3  = ""
  endif
  if sel = "Next Choice 3" then
           HLine1  = ""
           HLine2  = "                No Help Available"
           HLine3  = ""
  endif
  if sel = "Backup" then
           HLine1  = ""
           HLine2  = "        BACKUP a SINGLE or all FILES to DISK"
           HLine3  = ""
  endif
  if sel = "Date/Time" then
           HLine1  = "                   EXIT to DOS"
           HLine2  = "         RESET the SYSTEM Date and/or Time"
           HLine3  = ""
  endif
  if sel = "System/Analysis" then
           HLine1  = ""
           HLine2  = "    Run Statistics on the SYSTEM to evaluate Performance"
           HLine3  = ""
  endif
  if sel = "Quit" then
           HLine1  = ""
           HLine2  = "    Select this to GO BACK to the Previous Menu or to"
           HLine3  = "                 QUIT the SYSTEM                     "
  endif

  if isassigned(Hline1) = false and isassigned(Hline2) = false and
     isassigned(Hline3) = false then
          HLine1 = ""
          HLine2 = "                   HELP NOT AVAILABLE"
          HLine3 = ""
  endif

  CANVAS ON

  Style Attribute Color
  @TR+1,LC+2 ?? format("W55,AL",HLine1)
  @TR+2,LC+2 ?? format("W55,AL",HLine2)
  @TR+3,LC+2 ?? format("W55,AL",HLine3)

  style

  gc = getchar()

  @19,0 Clear EOS

  CURSOR NORMAL

  endproc

  writelib "MenuHelp" HelpMenu
