CreateLib "Menus"
@24,0 Clear EOL ?? "Creating MENUS library "
Style blink ?? "..."
style

Proc Closed PaintBox ()
UseVars BeginX,BeginY,Numberchoices,PopWidth,Color

Setmargin Beginy

Style attribute color
@Beginx,Beginy ?? ""+fill("",Popwidth-2)+""

for paintit from 1 to (Numberchoices-1) step 1
      @Beginx+Paintit,Beginy ?? ""+fill(" ",Popwidth-2)+""
endfor

@beginx+NumberChoices,beginy ?? ""+fill("",Popwidth-2)+""
SETMARGIN 0
EndProc

Proc Closed DrawPopBox ()

UseVars HelpMenu,MesgLibr,sel,n,Nick,C,D,last,nick,
        Beginx,BeginY,Numberchoices,Popwidth,Color,MenuName

 UpLCr = "" F_Hchar = ""  UpRCr = ""
             F_VChar = ""
LowLCr = ""               LowRCr = ""

  NumberLines = NumberChoices + 2
FillHLn = fill(F_Hchar,PopWidth-2)
FillBox = F_VChar + spaces(PopWidth-2) + F_VChar
m = beginy+2

Cursor Off

Style Attribute Color
@BeginX,BeginY ?? UpLCr + FillHLn + UpRCr
EndProc



Proc Closed FillMenu()

Usevars Beginx,beginy,m,PopWidth,Nick,Numberchoices,MenuName,c,d,last,nick,color,autolib,level,prevx,prevy,prevpw,prevnc

CANVAS OFF
CleanScreen()

TR = beginx+1
LC = beginy+2
BR = beginx+2+last
RC = beginy+1+popwidth

PAINTCANVAS Fill "" Attribute 113
TR,LC,BR,RC

Style Attribute Color
      m =  beginy+2

FillBox = ""+spaces(PopWidth-2)+""
FillHLn = fill("",PopWidth-2)

for CntBLine from 1 to NumberChoices step 1
      @BeginX+CntBLine,BeginY ?? FillBox
      if isassigned(C[CntBLine]) = true then
            @BeginX+CntBLine,m ?? C[CntBLine]
           NICK[CntBline] = substr(c[CntBLine],1,1)
      endif
Endfor
@BeginX+CntBLine,BeginY ?? "" + FillHLn + ""

lenmenu = len(MenuName)

if len(MenuName) < PopWidth-2 then
     padmenu = spaces((PopWidth-2)-lenmenu)
else
     padmenu = ""
endif

MenuName = MenuName+PadMenu
MenuName = format("AC,PopWidth-2",MenuName)

MenuLine = ""+format("AL,PopWidth",MenuName)+""

@BeginX,BeginY ?? MenuLine
style

CANVAS ON
EndProc

Proc Closed SelMenu ()
Usevars n,BeginX,Beginy,sel,m,color,c,d,last,level,Autolib,nick,popwidth

While (true)

; The following displays the menu item and description as top bars
; and highlights the item in the bar menu.

padchoice = fill(" ",(Popwidth-4)-len(c[n]))

style attribute 112    @0,0 ?? format("w79,ac",C[n])
style Attribute color  @1,0 ?? format("w79,ac",D[n])
style attribute 112    @beginx+n,beginy+2 ?? c[n],padchoice

; wait for the "user" to type a letter
  gc = getchar()
; evaluate the character and perform based on which character was chosen

Switch

CASE gc = -59 : sel = C[n]
                HelpMenu(sel)
                loop

CASE gc >= 48 and gc <= 122 :style attribute color
                             @beginx+n,beginy+2 ?? c[n],padchoice
                             SubMenu()
                             padchoice = fill(" ",(Popwidth-4)-len(c[n]))
                             sel = c[n]
                             style attribute 112

                             @beginx+n,beginy+2 ?? c[n],padchoice
                             quitloop

CASE gc = 27 :sel = "Esc"
              quitloop

CASE gc = 13 :@beginx+n,Beginy+2 ?? c[n],padchoice
              sel = c[n]
              quitloop

CASE gc = -71:Style attribute color     ; Home key is pressed
              @BeginX+n,m ?? c[n],padchoice
              n = 1
              loop

CASE gc = -79:                          ; End key is pressed
              Style attribute color
              @BeginX+n,beginy+2 ?? c[n],padchoice
              n = last
              loop

CASE gc = -72:                          ; Up key is pressed
              if n = 1 then
                   Style attribute color
                   @beginx+n,beginy+2 ?? c[n],padchoice
                   n = last
                   loop
              else
                   Style attribute color
                   @beginx+n,beginy+2 ?? c[n],padchoice
                   n = n - 1
                   loop
              endif

CASE gc = -80:                          ; Down key is pressed
              if n = last then
                   Style Attribute color
                   @beginx+n,beginy+2 ?? c[n],padchoice
                   n = 1
                   loop
              else
                   Style Attribute color
                   @beginx+n,beginy+2 ?? c[n],padchoice
                   n = n + 1
                   loop
              endif

OtherWise:Loop

EndSwitch

quitloop
Endwhile

endproc

Proc Closed SubMenu()
UseVars last,gc,c,d,sc,sd,nick,n,color,beginx,beginy
Private SubMa,SubMB,countit,look

While (true)

Array submA[last]
Array submB[last]

if gc > 90 then
     gc = gc - 32
endif

countit = 0

for look from 1 to last step 1
    if asc(nick[look]) = gc then
          n = look
          RETURN look
          countit = countit + 1
          subma[countit] = c[look]
          submB[countit] = d[look]
    endif
        n = look
endfor

if isassigned(subma[1]) = false then
      quitloop
endif

if countit = 1 then
      

      style reverse          @0,0 ?? SC[n]
      style Attribute color  @1,0 ?? SD[n]
      style reverse     @beginx+n,beginy+2 ?? c[n]
      sel = subma[countit]
      quitloop
endif

Array SubA[countit]
Array SubB[countit]

for assign from 1 to countit
      suba[assign] = subma[assign]
      subb[assign] = submb[assign]
      style reverse          @0,0 ?? SC[n]
      style Attribute color  @1,0 ?? SD[n]
      style reverse          @beginx+n,beginy+2 ?? c[n]
endfor


showarray
          subA subB

to sel

quitloop
endwhile
RETURN sel
endproc

Proc PopFileBox()


style attribute 79
@Beginx+n+1,m+2 ?? " File Ŀ"
@Beginx+n+2,m+2 ?? "        "
@Beginx+n+3,m+2 ?? ""

Style Reverse
@Beginx+n+2,m+4 ??
Accept "a8" to tablename

if isassigned(tablename) = false then
     RETURN tablename
endif

if tablename = "Esc" then
     RETURN tablename
endif

if tablename = "" or tablename = "?" then
     @0,0 Clear EOL
     @1,0 Clear EOL
     ShowTables
     Directory()
     format("W79,AC","Use the \017- -\016 keys...press \017 to select table")
     to tablename
     @Beginx+n+2,m+4 ?? tablename
endif

if tablename = "Esc" then

     RETURN tablename

endif

RETURN tablename

endproc

Proc Closed CheckTable(tablename)

if istable(tablename) = false then
     @24,0 Clear EOL ?? "No records in ",tablename
     beep
     sleep 500
     @24,0 Clear EOL
     tablename = "Escape"
     RETURN
endif

if nrecords(tablename) = 0 then
     @24,0 Clear EOL ?? "No records in ",tablename
     beep
     sleep 500
     @24,0 Clear EOL
     tablename = "Escape"
     RETURN
endif
endproc

Proc Closed CleanScreen ()
Usevars PopWidth, Beginx, numberchoices, beginy, level, prevx, prevy, prevnc, prevpw

if level > 1 then
       @PrevX[level-1],Prevy[level]+PrevPW[level]+1 Clear EOS
       @PrevX[level-1]+PrevNC[level-1]+1,PrevY[level] Clear EOS

endif
RETURN

EndProc

Proc ReDrawPopBox (level)


@0,0 Clear EOS

 UpLCr = "" F_Hchar = ""  UpRCr = ""
             F_VChar = ""
LowLCr = ""               LowRCr = ""
StopReDraw = level;-1

for counter from 1 to StopReDraw step 1
       BeginX =   Prevx[Counter]
       BeginY =   Prevy[Counter]
NumberChoices =  PrevNC[Counter]
     PopWidth =  PrevPW[Counter]
        Color =  PrevCL[Counter]
    MenuName  =  PrevML[counter]
            n =   PrevN[Counter]

  NumberLines = NumberChoices + 2
FillHLn = fill(F_Hchar,PopWidth-2)
FillBox = F_VChar + spaces(PopWidth-2) + F_VChar

Cursor Off

Style Attribute Color
@BeginX,BeginY ?? UpLCr + FillHLn + UpRCr

for CntBLine from 1 to NumberChoices step 1
      @BeginX+CntBLine,BeginY ?? FillBox
Endfor

      @BeginX+CntBLine,BeginY ?? LowLCr + FillHLn + LowRCr

      lenmenu = len(MenuName)

      if len(MenuName) < PopWidth-2 then
           padmenu = spaces((PopWidth-2)-lenmenu)
      else
           padmenu = ""
      endif

      MenuName = MenuName+PadMenu
      MenuName = format("AC,PopWidth-2",MenuName)

      MenuLine = UpLCr+format("AL,PopWidth",MenuName)+UpRCr

      @BeginX,BeginY ?? MenuLine

endfor
                  level = counter-1
                 BeginX = Prevx[Level]
                 BeginY = Prevy[Level]
          NumberChoices = PrevNC[Level]
               PopWidth = PrevPW[Level]
                  Color = PrevCL[Level]
                      n = PrevN[Level]
              MenuName  = PrevML[Level]

EndProc

Proc Closed NoDosExit(Pos)

NoDosMsg = format("AC,w79","Exit to DOS not allowed here")

if pos = "Top" then
      @0,0 Clear EOL ?? NoDosMsg
      beep sleep 1000
      RETURN
endif
if pos = "Bottom" then
      @24,0 Clear EOL ?? NoDosMsg
      beep sleep 1000
      RETURN
endif
if pos <> "Top" or pos <> "Bottom" then
      message NoDosMsg
      beep sleep 1000
      RETURN
endif

EndProc

WriteLib "Menus" DrawPopBox, SubMenu, PopFileBox, CheckTable, CleanScreen, ReDrawPopBox,
               SelMenu,FillMenu,PaintBox,NoDosExit
