;NEXTMENU.SC (ANY OTHER MENU IN POP-UP MENU SYSTEM)
;
;Script [NextMenu] Type [2nd/3rd Level] Call [AnyMenu]
;
;Description [This is a sample menu.]
;
;
;Created [07/31/90] By [G.Salcedo ]
;


   Prevx[Level] = BeginX
   Prevy[Level] = BeginY
  PrevNC[Level] = NumberChoices
  PrevPW[Level] = PopWidth
  PrevCL[Level] = Color
  PrevN[Level]  = n

              n = 1
          level = level + 1

         BeginX = Prevx[Level-1]+(n)
         BeginY = Prevy[Level-1]+2 ;

  NumberChoices = 5
       PopWidth = 20
          Color = 32
  MenuName =  format("AC,W18","Next Menu")

   Prevx[Level] = BeginX
   Prevy[Level] = BeginY
  PrevNC[Level] = NumberChoices
  PrevPW[Level] = PopWidth
  PrevCL[Level] = Color;
   PrevN[Level] = n
  PrevML[Level] = MenuName           ;


  While (true)


  ; this sets up arrays for all menu choices and the
  ; corresponding messages.
  ;
  ;        C[n] = menu items (the possible choices)
  ;        D[n] = descriptions of the menu items
  ;       SC[n] = "top bar" representation of menu item
  ;       SD[n] = "top bar"  description
  ;     NICK[n] = first letter of menu items

  Array         C[NumberChoices]
  Array         D[NumberChoices]
  Array      NICK[NumberChoices]


  ; These are the menu choices and the corresponding "wide"bar (top) display.
  ; Be sure to enclose the menu item in quotes. The number of characters in the
  ; menu items should not exceed PopWidth-2. Example "View".

  C[1] = "Next Choice 1"
  D[1] = "Perform Next #1"


  C[2] = "Next Choice 2"
  D[2] = "Perform Next #2"


  C[3] = "Next Choice 3"
  D[3] = "Perform Next #3"


  C[4] = "Next Choice 4"
  D[4] = "Perform Next #4"


  C[5] = "Quit"
  D[5] = "Exit to the MAIN Menu"



  if isassigned(n) = false then
       n = 1
  else
       n = n
  endif

  last = arraysize(c) ; Lets the procedure know the 'bottom' menu choice.

  ; This sets up the ability to graphically display the present menu level.


  FillMenu()
  SelMenu()
  if sel = "Esc" then
       @24,0 Clear EOL ?? format("w79,ac","One moment please ...")

               Level = Level - 1
              BeginX = Prevx[Level]
              BeginY = Prevy[Level]
       NumberChoices = PrevNC[Level]
         PopWidth = PrevPW[Level]
               Color = PrevCL[Level]
           MenuName  = PrevML[Level]
                   n = PrevN[Level]

       @24,0 Clear EOL
       reset
       quitloop
  else


  switch
            case sel = "Esc" :        Level = Level - 1
                                     BeginX = Prevx[Level]
                                     BeginY = Prevy[Level]
                              NumberChoices = PrevNC[Level]
                                   PopWidth = PrevPW[Level]
                                      Color = PrevCL[Level]
                                          n = PrevN[Level]
                                              reset
                                              quitloop
             case sel = c[1]  :""; play "next1"
             case sel = c[2]  :""; play "next2"
             case sel = c[3]  :""; play "next3"
             case sel = c[4]  :""; play "next4"
             case sel = c[5]  :       Level = Level - 1
                                     BeginX = Prevx[Level]
                                     BeginY = Prevy[Level]
                              NumberChoices = PrevNC[Level]
                                   PopWidth = PrevPW[Level]
                                      Color = PrevCL[Level]
                                          n = PrevN[Level]
                                               reset
                                               quitloop


  EndSwitch
  endif


  EndWhile

