; Ssedit03.sc


PROC GetDept()
 PRIVATE dept
  CLEAR
  dept = ""
  @ 5,0 ?? "Enter department to edit, press RETURN (\17\217) for lookup table: "
  STYLE REVERSE
  ACCEPT "A10" PICTURE "*!" TO dept
  STYLE
  IF retval = False THEN
    RETURN False
  ELSE
    IF ISBLANK(dept) THEN
      MOVETO "Dept"
      WHILE True
        WAIT TABLE
          PROMPT "Move cursor to Department to select",
                 "[F2]-Select    [Esc]-Cancel"
          UNTIL "F2","Esc","DOS","DOSBIG","ZOOM","ZOOMNEXT"
        SWITCH
          CASE retval = "F2"  : dept = [Department]  QUITLOOP
          CASE retval = "Esc" : dept = False         QUITLOOP
          OTHERWISE           : BEEP
        ENDSWITCH
      ENDWHILE
    ENDIF
  ENDIF
  RETURN dept
ENDPROC

PROC GetSubset()
  {Ask} {Employee} CHECK [Department] = dept
  DO_IT!
  IF ISEMPTY("Answer") THEN
    RETURN False
  ELSE
    RETURN True
  ENDIF
ENDPROC


PROC EditEmpByDept()                       ; Ssedit03.sc
 PRIVATE dept
;
; Private variables:
;   dept       - department to edit
;
  VIEW "Dept"
  dept = GetDept()                          ;  Get name of department to edit
  CLEAR
  IF dept = False THEN                      ;  If no department selected
    MESSAGE "No department selected"
    SLEEP 3000
  ELSE
    MESSAGE "Selecting employees in ",dept," department, please wait"
    CANVAS OFF
    VIEW "Employee"
    MOVETO [Department]
    LOCATE dept                             ;  Find the first dept
    IF retval = False THEN                  ;  If not records for dept
      CANVAS ON
      MESSAGE "No employees in ",dept," department"
      SLEEP 3000
      RETURN
    ENDIF
    COEDITKEY
    PICKFORM 1
    CTRLHOME                                ;  Move to first field on form
    CANVAS ON
    msg = ""                                ;  Initialize msg variable
    WHILE True
      WAIT RECORD
        PROMPT "Edit record    [F2]-Save/Exit    [F3]-Next Table   " +
               "[PgDn]-Next Record"
        MESSAGE msg
        UNTIL "F3","PgDn","F2","DOS","DOSBIG","ZOOM","ZOOMNEXT"
      msg = ""
      SWITCH
        CASE retval = "F3"   :
             DOWNIMAGE
             LOOP
        CASE retval = "PgDn" :
             SWITCH
               CASE TABLE() = "Employee" :
                   SKIP                     ;  Move to next record.  If this is
                   IF EOT() THEN            ; the last record notify the user.
                     msg = "No more " + dept + " records!"
                   ELSE
                     MOVETO [Department]
                     LOCATE NEXT dept       ;  Find the next record
                     IF retval = False THEN ;  No more records, put cursor
                       SKIP -1              ; on last record that matched
                       msg = "No more " + dept + " records!"
                     ENDIF
                     CTRLHOME               ;  Move to first field on form
                   ENDIF
                   LOOP
              CASE TABLE() = "Benefits" :
                   BEEP
                   LOOP
              CASE TABLE() = "Depndnts" :
                   SKIP
                   LOOP
            ENDSWITCH
        CASE retval = "F2"   :  QUITLOOP
        OTHERWISE            :  BEEP
      ENDSWITCH
    ENDWHILE
    MESSAGE "Editing complete"
    SLEEP 3000
    DO_IT!
  ENDIF
ENDPROC


RELEASE VARS ALL
RESET
CURSOR OFF
EditEmpByDept()
CLEARALL
