; ViewTbls.sc

PROC ViewTbls()
WHILE True
  numofimages = NIMAGES()                    ;  Save the number of images in a
                                             ; variable to prevent repeated
                                             ; calls the NIMAGES()

  IF numofimages = 1 THEN                    ;  Use two different WAIT TABLE
                                             ; statements depending on the
                                             ; number of images on the workspace
      WAIT TABLE
        PROMPT "Viewing Single Table   [F2]-Exit   [F10]-Table Menu",
               "[F7]-Form/Table View Toggle"
        UNTIL "F7","F2","F10","DOS","DOSBIG","ZOOM","ZOOMNEXT"
  ELSE
    WAIT TABLE
      PROMPT "Viewing Table " + STRVAL(IMAGENO())  + " of " +
             STRVAL(numofimages) + "    [F2]-Exit   [F10]-Table Menu   " +
             "[T]-Size Image",
             "[F3]-Next Table   [F4]-Previous Table   " +
             "[F7]-Form/Table View Toggle"
      UNTIL "F3","F4","F10","T","t","F7","F2","DOS","DOSBIG","ZOOM","ZOOMNEXT"
  ENDIF
  SWITCH
    CASE retval = "F3"       : UPIMAGE           LOOP
    CASE retval = "F4"       : DOWNIMAGE         LOOP
    CASE retval = "ZOOM"     : ZoomMenu()        LOOP
    CASE retval = "ZOOMNEXT" : ZoomNextProc()    LOOP
    CASE retval = "F10"      : ViewTblsMenu()    LOOP   ; Get another table
    CASE retval = "F7"       : FORMKEY           LOOP
    CASE retval = "T" OR                         ;  Allow user to size the
         retval = "t"     :                      ; the number of rows shown
         WHILE (true)                            ; for the current table
           Menu {Image} {TableSize}
           WAIT TABLE
             PROMPT "Use UpArrow to decrease the table by one row;" +
                    " DownArrow to increase by one row...",
                    "then press Enter when finished"
             UNTIL "ENTER","DOS","DOSBIG"
             IF retval = "ENTER" THEN QUITLOOP ENDIF
          ENDWHILE
          ENTER                                  ;  Ends TableSize command
          LOOP
    CASE retval = "F2"   : QUITLOOP
    OTHERWISE            : BEEP LOOP
  ENDSWITCH
ENDWHILE
CLEARALL
CLEAR
RETURN
ENDPROC


