;ͻ
;G.Salcedo     ParaDocs     03/01/90                                  
;                                                                     
;This Library provides for calculations of time intervals             
;ͼ

CreateLib "time"

Proc Closed CalcTime(D,SW)

timecalc = (D-1/1/00) +   (numval(substr(sw,1,2))/24)+
                          ((numval(substr(sw,4,2))/60)/24)+
                          (((numval(substr(sw,7,2))/60)/60)/24)
Return timecalc
EndProc

Proc Trans_Int(Interval)

if interval < 1 and interval >-1 then

        nodays = 0

      evaltime =interval
else
        nodays = int(interval)
      evaltime = interval-nodays
endif

    ndays = (nodays)

NoSecsDay = 86400

NoTotSecs = round(evaltime * NoSecsDay,0)

NoTotMins = int(mod(nototsecs/60,60))

NoTotHrs  = int(mod(nototsecs/3600,60));round(NoTotSecs/3600,0)
     Hrs  = format("W3,EZ",NoTotHrs)
     Sec  = format("W3,EZ",mod(NoTotSecs,60))

if mod(NoTotSecs,60) > 0 then
     Mnn = format("W3,EZ",round(NoTotMins+.49,0))
else
     Mnn = format("W3,EZ",round(NoTotMins+.49,0))
endif

Ret_interval = format("W5,SP",Ndays)+" days and "+substr(Hrs,2,2)+":"+
                                                  substr(Mnn,2,2)+":"+
                                                  substr(Sec,2,2)

Return Ret_interval
EndProc

Proc Record_Int(FileName,Phrase,Interval)

if interval < 1 and interval >-1 then
        nodays = 0
      evaltime =interval
else
        nodays = int(interval)
      evaltime = interval-nodays
endif

    ndays = nodays

NoSecsDay = 86400

NoTotSecs = round(evaltime * NoSecsDay,0)

NoTotMins = int(mod(nototsecs/60,60))

NoTotHrs  = int(mod(nototsecs/3600,60));round(NoTotSecs/3600,0)
     Hrs  = format("W3,EZ",NoTotHrs)
     Sec  = format("W3,EZ",mod(NoTotSecs,60))

if mod(NoTotSecs,60) > 0 then
     Mnn = format("W3,EZ",round(NoTotMins+.49,0))
else
     Mnn = format("W3,EZ",round(NoTotMins+.49,0))
endif


Rectime  = substr(Hrs,2,2)+":"+
           substr(Mnn,2,2)+":"+
           substr(Sec,2,2)

Ret_interval = format("w5,EP",Ndays)+" days and "+Rectime

          Print File FileName  Phrase,",",Ndays,",",RecTime,"\n\r"

Return Ret_interval
EndProc

writelib "time" CalcTime,Trans_Int,Record_int
