LibName = "QueryLb1"
@24,0 Clear EOL ?? "Creating ",LibName
Style blink ?? "..."
style

CreateLib LibName

Proc Query1 ()

Query

 Bookord |     Cust      |    Date    |   Item #   |      Vol       |
         | CheckPlus _id | CheckPlus  | CheckPlus  | CheckPlus _vol |
         |               |            |            |                |
         |               |            |            |                |

 Bookord |      Quant       |   Emp #    |
         | CheckPlus _quant | CheckPlus  |
         |                  |            |
         |                  |            |

 Customer |    Cust ID    | Last Name  |    Init    |   Street   |
          | CheckPlus _id | CheckPlus  | CheckPlus  | CheckPlus  |
          |               |            |            |            |
          |               |            |            |            |

 Customer |    City    |   State    |    Zip     |  Country   |   Credit   |
          | CheckPlus  | CheckPlus  | CheckPlus  | CheckPlus  | CheckPlus  |
          |            |            |            |            |            |
          |            |            |            |            |            |

 Vols |     Vol #      |   Title    |    Book    |                    Price                     |
      | CheckPlus _vol | CheckPlus  | CheckPlus  | CheckPlus _price,calc _price*_quant as Total |
      |                |            |            |                                              |
      |                |            |            |                                              |

Endquery

Do_it!
EndProc

Proc Query2()
Query

 Masterbk |             Total             |
          | calc average all as "Average" |
          |                               |
          |                               |

 Masterbk |
          |
          |
          |

Endquery
Do_it!
EndProc

Proc Query3()
Query

 Masterbk |              Total              |
          | calc count all as "Total Count" |
          |                                 |
          |                                 |

 Masterbk |
          |
          |
          |

Endquery
Do_it!
EndProc

Proc Query4()
Query

 Masterbk |              Total              |
          | calc max all as "Maximum Value" |
          |                                 |
          |                                 |

 Masterbk |
          |
          |
          |

Endquery
Do_it!
EndProc

Proc Query5()
Query

 Masterbk |              Total              |
          | calc min all as "Minimum Value" |
          |                                 |
          |                                 |

 Masterbk |
          |
          |
          |

Endquery
Do_it!
EndProc

Proc Query6()
Query

 Masterbk |          Total          |
          | calc sum all as "Total" |
          |                         |
          |                         |

 Masterbk |
          |
          |
          |

Endquery
Do_it!
EndProc

Proc Query1a()

Query

 Bookord |     Cust      |    Date    |   Item #   |      Vol       |
         | CheckPlus _id | CheckPlus  | CheckPlus  | CheckPlus _vol |

 Bookord |      Quant       |   Emp #    |
         | CheckPlus _quant | CheckPlus  |

 Customer |    Cust ID    | Last Name  |    Init    |   Street   |
          | CheckPlus _id | CheckPlus  | CheckPlus  | CheckPlus  |

 Customer |    City    |   State    |    Zip     |  Country   |   Credit   |
          | CheckPlus  | CheckPlus  | CheckPlus  | CheckPlus  | CheckPlus  |

 Vols |     Vol #      |   Title    |    Book    |                    Price                     |
      | CheckPlus _vol | CheckPlus  | CheckPlus  | CheckPlus _price,calc _price*_quant as Total |

Endquery

Do_it!
EndProc

Proc Query2a()
Query

 Masterbk |             Total             |
          | calc average all as "Average" |

 Masterbk |
          |

Endquery
Do_it!
EndProc

Proc Query3a()
Query

 Masterbk |              Total              |
          | calc count all as "Total Count" |

 Masterbk |
          |

Endquery
Do_it!
EndProc

Proc Query4a()
Query

 Masterbk |              Total              |
          | calc max all as "Maximum Value" |

 Masterbk |
          |

Endquery
Do_it!
EndProc

Proc Query5a()
Query

 Masterbk |              Total              |
          | calc min all as "Minimum Value" |

 Masterbk |
          |

Endquery
Do_it!
EndProc

Proc Query6a()
Query

 Masterbk |          Total          |
          | calc sum all as "Total" |

 Masterbk |
          |

Endquery
Do_it!
EndProc

Proc Query1b()

menu {ask} {bookord}
CheckPlus
moveto[cust]
Example "id"
moveto[vol]
Example "vol"
moveto[quant]
Example "quant"

menu {ask} {customer}
CheckPlus
moveto[cust id]
Example "id"

menu {ask} {vols}
CheckPlus
moveto[vol #]
CheckPlus
Example "vol"
moveto[price]
Example "price"
",calc "
Example "price"
"*"
Example "quant"
" as Total"
Do_it!
EndProc

Proc Query2b()
menu {ask} {masterbk}
moveto[total]
"calc average all as \"average\""
Do_it!
EndProc

Proc Query3b()

menu {ask} {masterbk}
moveto[total]
"calc count all as \"Total Count\""
Do_it!
EndProc

Proc Query4b()

menu {ask} {masterbk}
moveto[total]
"calc max all as \"Maximum Value\""
Do_it!
EndProc

Proc Query5b()

menu {ask} {masterbk}
moveto[total]
"calc min all as \"Minimum Value\""
Do_it!
EndProc

Proc Query6b()

menu {ask} {masterbk}
moveto[total]
"calc sum all as \"Total\""
Do_it!
EndProc


Proc CalcDiff()
Query

 Listproc | QueryForm | QueryForm Trimmed |    Diff % Query/Trimmed     |
          | _a        | _b                | changeto (1-(_b/_a))*100*-1 |
          |           |                   |                             |
          |           |                   |                             |

 Listproc | QueryForm PAL  |      Diff % Query/PAL       |     Diff % Trimmed/PAL         |
          | _c             | changeto (1-(_c/_a))*100*-1 | changeto (1-(_c/_b))/_b*100*-1 |
          |                |                             |                                |
          |                |                             |                                |

Endquery
Do_it!
EndProc

Proc CalcDiffa()
Query

 Listproc | QueryForm | QueryForm Trimmed |    Diff % Query/Trimmed    |
          | _a        | _b                | changeto (_b-_a)/_a*100*-1 |

 Listproc | QueryForm PAL |      Diff % Query/PAL      |     Diff % Trimmed/PAL     |
          | _c            | changeto (_c-_a)/_a*100*-1 | changeto (_c-_b)/_b*100*-1 |

Endquery
Do_it!
EndProc

Proc CalcDiffb()

menu {ask} {listproc}
Right Right Example "a"
Right Example "b"
Right Right Example "c"
Left
"changeto ("
Example "b"
"-"
Example "a"
")/"
Example "a"
"*100*-1"
Right Right
"changeto ("
Example "c"
"-"
Example "a"
")/"
Example "a"
"*100*-1"
Right
"changeto ("
Example "c"
"-"
Example "b"
")/"
Example "b"
"*100*-1"
Do_it!
EndProc

Proc CalcDiffc()
menu {ask}{listProc}
moveto[queryform] Example "a"
moveto[queryform trimmed] Example "b"
moveto[diff % query/trimmed];Right
"changeto (1-("
Example "b" "/"
Example "a"
"))*100*-1"
moveto[queryform pal];Right
Example "c"
moveto[diff % query/pal];Right
"changeto (1-("
Example "c" "/"
Example "a"
"))*100*-1"
moveto[diff % trimmed/pal] ;Right
"changeto (1-("
Example "c" "/"
Example "b"
"))*100*-1"
Do_it!
EndProc


Proc CalcDiffd()
menu {ask}{listProc}
moveto[queryform] Example "a"
moveto[queryform trimmed] Example "b"
Right
"changeto (1-("
Example "b" "/"
Example "a"
"))*100*-1"
Right
Example "c"
Right
"changeto (1-("
Example "c" "/"
Example "a"
"))*100*-1"
Right
"changeto (1-("
Example "c" "/"
Example "b"
"))*100*-1"
Do_it!
EndProc


WriteLib LibName Query1,Query2,Query2,Query3,Query4,Query5,Query6,
                 Query1a,Query2a,Query2a,Query3a,Query4a,Query5a,Query6a,
                 Query1b,Query2b,Query2b,Query3b,Query4b,Query5b,Query6b,
                 CalcDiff,CalcDiffA,CalcDiffb,CalcDiffc,CalcDiffd
