; student editing script

; ******** designates new statement added to application to facilitate
;          the concept of shadow tables

VIEW   "SHADOW\\student" ; ***************
CoEdit "student"

msg.text = ""
WHILE true
   FirstShow ;*******************
   CtrlHome Right     ; move to first field in table view
   ImageRights READONLY
   WAIT TABLE
      PROMPT FORMAT("AL,W6",UserName())+"          F9: Edit grades info    ;    Esc: Leave"
      MESSAGE msg.text
   UNTIL "F9","Esc"
   ImageRights
   msg.text = ""
   SWITCH
      CASE RETVAL = "F9"  :
         LockRecord
         IF RETVAL = false THEN
            BEEP
            msg.text = "Record is in use by "+UserName()
         ELSE
            
            CopyToArray rec.contents      ;***********
            MOVETO "SHADOW\\STUDENT"      ;***********
            PICKFORM "2"                  ;***********
            Ins                           ;***********
            CopyFromArray rec.contents    ;***********
            resynckey                     ;***********
            
            MOVETO "grades" ; moveto the detail table
            WAIT TABLE
               PROMPT "Make changes, additions and deletions; Press F2 when done"
            UNTIL "F2"
            UnLockRecord
            UnLockRecord              ; destroy key violations
            IF NImageRecords() = 1 AND
               IsBlank([YEAR]) THEN ; there is only one, blank rec in table
               DEL
            ENDIF
            
            MOVETO "SHADOW\\STUDENT"      ;***********
            DEL                           ;***********
            LockRecord                    ;***********
            UnLockRecord                  ;***********
            FormKey                       ;***********
            
            MOVETO "student"          ; go up to the master table
            UnLockRecord              ; unlock the master record
         ENDIF
         
      CASE RETVAL = "Esc" :
         QUITLOOP
         
   ENDSWITCH
ENDWHILE
Do_It!
ClearAll

RELEASE VARS msg.text
