; student editing script

; ******** designates new statement added to application to facilitate
;          the concept of shadow tables

AUTOLIB = "utillib"

VIEW   "SHADOW\\student" ; ***************
CoEdit "student"

msg.text = ""
WHILE true
   FirstShow ;*******************
   CtrlHome Right     ; move to first field in table view
   ImageRights READONLY
   WAIT TABLE
      PROMPT FORMAT("AL,W6",UserName())+"          F9: Edit grades info    ;    Esc: Leave"
      MESSAGE msg.text
   UNTIL "F9","Esc"
   ImageRights
   msg.text = ""
   SWITCH
      CASE RETVAL = "F9"  :
         LockRecord ; lock the master record
         IF RETVAL = false THEN
            BEEP
            msg.text = "Record is in use by "+UserName()
         ELSE

            begin_shadow("student","2") ;*******************

            MOVETO "grades" ; moveto the detail table
            WAIT TABLE
               PROMPT "Make changes, additions and deletions; Press F2 when done"
            UNTIL "F2"
            UnLockRecord
            UnLockRecord              ; destroy key violations
            IF NImageRecords() = 1 AND
               IsBlank([YEAR]) THEN ; there is only one, blank rec in table
               DEL
            ENDIF

            end_shadow("student")     ;*******************

            UnLockRecord              ; unlock the master record

         ENDIF

      CASE RETVAL = "Esc" :
         QUITLOOP

   ENDSWITCH
ENDWHILE
Do_It!
ClearAll

RELEASE VARS msg.text
