; Coninfo2

;  Example of SQLCONNECTINFO for replica tables


CLEAR
WHILE True
  SHOWTABLES
  DIRECTORY()
  "Select table name to get server connect information for, [Esc] to cancel"
  TO tblname
  IF tblname = "Esc" OR tblname = "None"  THEN
    CLEAR
    MESSAGE("No table selected or none available!")
    SLEEP 3000
    QUITLOOP
  ENDIF

  MESSAGE "Getting information on ", tblname," replica table, Please wait!"
  CANVAS OFF
  IF NOT SQLISREPLICA(tblname) THEN
    BEEP SLEEP 100 BEEP SLEEP 100 BEEP
    MESSAGE "Table ",tblname," is not a replica table!"
  ELSE
    CLEAR
    @ 5,0
    ?? "Connection Information for " + tblname + " replica table"
    ? ""
    ?  "Title      : " + SQLCONNECTINFO("TITLE",tblname)
    ?  "Description: " + SQLCONNECTINFO("DESCRIPTION",tblname)
    ?  "Product    : " + SQLCONNECTINFO("PRODUCT",tblname)
    ?  "Dialect    : " + SQLCONNECTINFO("DIALECT",tblname)
  ENDIF
  @ 24,0 ?? "Press any key to continue"
  CANVAS ON
  kp = GETCHAR()
  @ 24,0 CLEAR EOL
ENDWHILE
RELEASE VARS kp, tblname
