;***************************************************************************
; Script [LesnMenu]
; Description [This section provides View, Browse, Edit and DataEntry
;              functions.                                               ]
; Created [05/30/90] By [G.Salcedo ]
;***************************************************************************


 Prevx[Level] = BeginX
 Prevy[Level] = BeginY
PrevNC[Level] = NumberChoices
PrevPW[Level] = PopWidth
PrevCL[Level] = Color
 PrevN[Level] = n
PrevML[Level] = MenuName

            n = 1
        level = level + 1

       BeginX = Prevx[Level-1]+(n)
       BeginY = Prevy[Level-1]+2

NumberChoices = 7                   ;
     PopWidth = 20                  ; Current menu values.
        Color = 15                  ;
     MenuName = "Music Lessons"     ;


 Prevx[Level] = BeginX
 Prevy[Level] = BeginY
PrevNC[Level] = NumberChoices
PrevPW[Level] = PopWidth
PrevCL[Level] = Color
 PrevN[Level] = n
PrevML[Level] = MenuName




While (true)


; this sets up the arrays for all the menu choices and the
; corresponding messages.
;
;        C[n] = menu items (the possible choices)
;        D[n] = descriptions of the menu items
;     NICK[n] = first letter of menu items

Array         C[NumberChoices]
Array         D[NumberChoices]
Array      NICK[NumberChoices]

; These are the menu choices and the corresponding "wide" bar (top) display.
; Be sure to enclose the menu item in quotes. The number of characters in the
; menu items should not exceed PopWidth-2. Example "View".

C[1] = "Students"
D[1] = "View the Students List"

C[2] = "Current"
D[2] = "View the Class Schedule"

C[3] = "Forecast"
D[3] = "Project the Class Schedule"

C[4] = "New"
D[4] = "Enter a new student"

C[5] = "Enroll"
D[5] = "Place a student in a class"

C[6] = "Print"
D[6] = "Print class schedule"

C[7] = "Quit"
D[7] = "Exit to the MAIN Menu"


if isassigned(n) = false then
     n = 1
else
     n = n
endif

last = arraysize(c)

FillMenu()
SelMenu()

if sel = "Esc" then
     @24,0 Clear EOL ?? format("w79,ac","One moment please ...")
        Level = Level - 1
       BeginX = Prevx[Level]
       BeginY = Prevy[Level]
NumberChoices =  PrevNC[Level]
     PopWidth =  PrevPW[Level]
        Color =  PrevCL[Level]
            n =   PrevN[Level]
    MenuName  = PrevML[Level]
     @24,0 Clear EOL
     reset
     quitloop
else


switch
       case sel = "Esc" :        Level = Level - 1
                                BeginX = Prevx[Level]
                                BeginY = Prevy[Level]
                         NumberChoices = PrevNC[Level]
                              PopWidth = PrevPW[Level]
                                 Color = PrevCL[Level]
                                     n = PrevN[Level]
                             MenuName  = PrevML[Level]
                                         quitloop
      case sel = c[1]  : pform = "F"  tablename = "Student"  play "ViewStd"
      case sel = c[2]  : pform = "F"  tablename = "dates"    play "ViewSchd"
      case sel = c[3]  : play "proj_sch"
      case sel = c[4]  : play "newstd"
      case sel = c[5]  : play "schedstd"
      case sel = c[6]  : play "prntschd"
      case sel = c[7]  :        Level = Level - 1
                                BeginX = Prevx[Level]
                                BeginY = Prevy[Level]
                         NumberChoices = PrevNC[Level]
                              PopWidth = PrevPW[Level]
                                 Color = PrevCL[Level]
                                     n = PrevN[Level]
                             MenuName  = PrevML[Level]
                                         reset
                                         quitloop

OtherWise:Loop

EndSwitch
endif

EndWhile

