; MkUtil.sc

;  This is the driver script to create the utility library

libname = "Util"
CLEAR
@ 2,0 ?? "Creating library ",libname
@ 3,0
CREATELIB libname

?? "."
PLAY "Beeps"
WRITELIB libname Beeps
RELEASE PROCS Beeps

?? "."
PLAY "ShowMsg"
WRITELIB libname ShowMsg
RELEASE PROCS ShowMsg

?? "."
PLAY "Clrqry"
WRITELIB libname ClearQueryImages
RELEASE PROCS ClearQueryImages

?? "."
PLAY "Expldwin"
WRITELIB libname ExplodeWindow
RELEASE PROCS ExplodeWindow

?? "."
PLAY "Prntron"
WRITELIB libname PrinterOn
RELEASE PROCS PrinterOn

?? "."
PLAY "Fillwin"
WRITELIB libname FillWindow
RELEASE PROCS FillWindow

?? "."
PLAY "KeyVioln"
WRITELIB libname AnyKeyViol, SaveRcd
RELEASE PROCS AnyKeyViol, SaveRcd


?? "."
PROC SetGraphTitle(title1text,title2text)
  IF SYSMODE() = "Main" THEN               ;  If in Main Mode
    MENU {Image} {Graph} {Modify}          ; place in graph mode
  ENDIF                                    ; otherwise assumption in Graph Mode
  MENU {Overall} {Titles}
  CTRLBACKSPACE
  TYPEIN title1text
  Enter Enter CTRLBACKSPACE
  TYPEIN title2text
ENDPROC

WRITELIB libname SetGraphTitle
RELEASE PROCS SetGraphTitlte



?? "."
PROC NotDefined()
  Beeps()
  ShowMsg("Selection is not currently defined!","OFF","Y",2000)
ENDPROC

WRITELIB libname NotDefined
RELEASE PROCS NotDefined

?? "."
PROC RetrieveMsg(txtmsg)
  @ 24,0 ?? txtmsg + ", "
  STYLE BLINK
  ?? "Please wait"
  STYLE
ENDPROC

WRITELIB libname RetrieveMsg
RELEASE PROCS RetrieveMsg



?? "."
PLAY "ErrProc"
WRITELIB libname ErrorProcedure
RELEASE PROCS ErrorProcedure

?? "."
PLAY "ErrPrnt"
WRITELIB libname ErrorPrint
RELEASE PROCS ErrorPrint


INFOLIB "Util"
