;
; Script [MesgLibr]            Type [Help    ]         Called from [Menus  ]
;
; Description [Provides Help for all Menu Choices                           
;                                                                          ]
;
; Created [04/12/88] By [G.Salcedo ] Revised [__/__/__] By [            ]   
;

@24,0 Clear EOL ?? "Compiling MMesgLib"
Style Blink ?? "..."
Style

createlib "MMesgLib"

Proc MessgBox(Msg)

@20,10 Clear EOS ?? "ͻ"
@21,10           ?? "                                                        "
@22,10           ?? "                                                        "
@23,10           ?? "                                                        "
@24,10           ?? "ͼ"

                   ;....+...10....+...20....+....30....+...40....+...50....+.
if msg = 1 then
         MLine1  = "To select a TABLE, type in the TABLE name and press "
         MLine2  = ""
         MLine3  = "To see a list of all tables press  and then SELECT"
endif
if msg = 2 then
         MLine1  = ""
         MLine2  = " PLEASE FILL IN THE LAST NAME TO ASSIGN CUSTOMER #   "
         MLine3  = ""
endif
if msg = 3 then
         MLine1  = ""
         MLine2  = "     MUST SUPPLY A QUANTITY AMOUNT"
         MLine3  = ""
endif
if msg = 4 then
         MLine1  = ""
         MLine2  = "   CANNOT ASSIGN A CUSTOMER NUMBER TO EXISTING ACCOUNT"
         MLine3  = ""
endif

if msg = 10 then
         MLine1  = ""
         MLine2  = "         UNABLE to access INVOICE # CONTROL TABLE..."
         MLine3  = "         CONTACT your systems administrator"
endif
if msg = 100 then
         MLine1  = "            Data has not been posted to the system..."
         MLine2  = ""
         MLine3  = "            CONTACT your systems administrator"
endif
if msg = 90 then
         MLine1  = ""
         MLine2  = "                UNABLE TO ACCESS TABLE"
         MLine3  = ""
endif
if msg = 91 then
         MLine1  = "            UNABLE to ADD ENTRY table..."
         MLine2  = "            SEE SYSTEM ADMINISTRATOR!"
         MLine3  = ""
endif
if msg = 94 then
         MLine1  = ""
         MLine2  = "     UNABLE TO CREATE DATAENTRY TABLE"
         MLine3  = ""
endif
if msg = 95 then
         MLine1  = ""
         MLine2  = "          UNABLE TO ASSIGN INVOICE #"
         MLine3  = ""
endif
if msg = 96 then
         MLine1  = ""
         MLine2  = "           LOOKING UP NEW INVOICE # "
         MLine3  = ""
endif
if msg = 97 then
         MLine1  = ""
         MLine2  = "                ONE MOMENT PLEASE       "
         MLine3  = ""
endif
if msg = 98 then
         MLine1  = ""
         MLine2  = "           PERFORMING BACKUP AND ANALYSIS"
         MLine3  = ""
endif
if msg = 99 then
         MLine1  = ""
         MLine2  = "               UNABLE to PERFORM BACKUP/COPY"
         MLine3  = "                        CALL [SUPPORT]"
endif

Style Attribute Color
@21,12 ?? format("W54,AL",MLine1)
@22,12 ?? format("W54,AL",MLine2)
@23,12 ?? format("W54,AL",MLine3)
Style

if msg < 90 then
     gc = getchar()
     @20,0 Clear EOS
else
     sleep 500
endif

Release vars Mline1,Mline2,Mline3,gc,Msg

endproc
Proc PerCentBar()

@20,0 Clear EOS

Style Attribute Color
@21,12 ?? " 0   10   20   30   40   50   60   70   80   90  100 "
@22,12 ?? " Ĵ "
style
endproc

Proc Scale(Eval)

scalechar = ""

   Style Attribute Color+16
   fillbar = int(eval/2)
   @23,13 ?? fill(scalechar,fillbar)
   style

endproc

Proc ClearMsg()
        @20,0 Clear EOS
EndProc


Style
@24,0 Clear EOL
Clear

writelib "MMesgLib" MessgBox, PerCentBar, Scale, ClearMsg

