;***************************************************************************
; Script [ModiMenu]
; Description [This section provides View, Browse, Edit and DataEntry
;              functions.                                               ]
; Created [05/30/90] By [G.Salcedo ]
;***************************************************************************


 Prevx[Level] = BeginX
 Prevy[Level] = BeginY
PrevNC[Level] = NumberChoices
PrevPW[Level] = PopWidth
PrevCL[Level] = Color
 PrevN[Level] = n
PrevML[Level] = MenuName

            n = 1
        level = level + 1

       BeginX = Prevx[Level-1]+(n)
       BeginY = Prevy[Level-1]+2

NumberChoices = 6                   ;
     PopWidth = 20                  ; Current menu values.
        Color = 15                  ;
     MenuName = "Administration"    ;


 Prevx[Level] = BeginX
 Prevy[Level] = BeginY
PrevNC[Level] = NumberChoices
PrevPW[Level] = PopWidth
PrevCL[Level] = Color
 PrevN[Level] = n
PrevML[Level] = MenuName




While (true)


; this sets up the arrays for all the menu choices and the
; corresponding messages.
;
;        C[n] = menu items (the possible choices)
;        D[n] = descriptions of the menu items
;     NICK[n] = first letter of menu items

Array         C[NumberChoices]
Array         D[NumberChoices]
Array      NICK[NumberChoices]

; These are the menu choices and the corresponding "wide" bar (top) display.
; Be sure to enclose the menu item in quotes. The number of characters in the
; menu items should not exceed PopWidth-2. Example "View".

C[1] = "Customer"
D[1] = "View/Edit/Enter CUSTOMER table"

C[2] = "Products"
D[2] = "View/Edit/Enter inventory"

C[3] = "Reports"
D[3] = "Go to the Reports Menu"

C[4] = "Invoice"
D[4] = "Create a New Invoice"

C[5] = "Accounts"
D[5] = "View the CUSTOMER and ACCOUNTS table"

C[6] = "Quit"
D[6] = "Exit to the MAIN Menu"


if isassigned(n) = false then
     n = 1
else
     n = n
endif

last = arraysize(c)

FillMenu()
SelMenu()

if sel = "Esc" then
     @24,0 Clear EOL ?? format("w79,ac","One moment please ...")
        Level = Level - 1
       BeginX = Prevx[Level]
       BeginY = Prevy[Level]
NumberChoices =  PrevNC[Level]
     PopWidth =  PrevPW[Level]
        Color =  PrevCL[Level]
            n =   PrevN[Level]
    MenuName  = PrevML[Level]
     @24,0 Clear EOL
     reset
     quitloop
else


switch
       case sel = "Esc" :        Level = Level - 1
                                BeginX = Prevx[Level]
                                BeginY = Prevy[Level]
                         NumberChoices = PrevNC[Level]
                              PopWidth = PrevPW[Level]
                                 Color = PrevCL[Level]
                                     n = PrevN[Level]
                             MenuName  = PrevML[Level]
                                         quitloop
      case sel = c[1]  : pform = "F"  tablename = "Customer" play "ViewCust"
      case sel = c[2]  : pform = "1"  tablename = "Products" play "ViewProd"
      case sel = c[4]  : play "EnterInv"
      case sel = c[3]  : play "reptmenu"
      case sel = c[5]  : pform = "1" tablename = "Customer"  play "EditCust"
      case sel = c[6]  :        Level = Level - 1
                                BeginX = Prevx[Level]
                                BeginY = Prevy[Level]
                         NumberChoices = PrevNC[Level]
                              PopWidth = PrevPW[Level]
                                 Color = PrevCL[Level]
                                     n = PrevN[Level]
                             MenuName  = PrevML[Level]
                                         reset
                                         quitloop

OtherWise:Loop

EndSwitch
endif

EndWhile

