;**************************************************************************
;Script:PrepTabl
;Description:Creates an ENTRY TABLE for INVOICE and CUSTOMER
;            as the user enters the system
;Created [5/26/90    ] By [G.Salcedo ]
;**************************************************************************

Proc ChgCustomer()

Menu {Forms} {Change} select shadow+"\\custmstr"
{2} Enter
mesg = Window()
message mesg  sleep 1000
Down Down Down Down Down Down Down Down
if ismultiform(shadow+"\\custmstr","2") = true then
     Menu {Multi} {Tables} {Remove} Enter {OK}
endif
Menu {Multi} {Tables} {Place} {Linked}
select shadow+"\\Invoice" {1} {Customer Number} Up Up Up
Up Enter Do_It!

RETURN
EndProc

Proc ChgPurchase()

Menu {Forms} {Change} select shadow+stablename {F} {Purchase Order}
mesg = window()
message mesg sleep 1000
Down Down Down Down Down Down Down Down Down Right Right Right
Right Right Right Right Right Right Right Right Right Right
Right Right Right Right Right
Menu {Multi} {Tables} {Place} {Linked}
select shadow+"\\Prchdetl" {F} {Purchase Order #} Up Up Up
Up Left Left Left Left Left Left Left Left Left Left Left Left
Left Left Left Left Left Enter Do_It!

RETURN
EndProc


Proc SetupTable(tablename)

stablename = "\\"+tablename

if istable(shadow+stablename) = false then

While (true)
MessgBox(97)

LOCK tablename PFL

if retval = true then
     COPY tablename shadow+stablename  ;invoice copy
else
          MessgBox(94)
          loop
endif


UNLOCK tablename PFL

quitloop
EndWhile
endif

if tablename = "Custmstr" then
        message "changing customer form"
        beep
        ChgCustomer()
endif
if tablename = "Prchmstr" then
        message "changing prchmstr form"
        beep
        ChgPurchase()
endif

RETURN

EndProc


shadow = privdir()+"shadow"

if direxists(shadow) = 0 then
    @0,0 Clear EOL ??  "Making a SHADOW directory"
    sleep 1000
    style blink ?? "..." style
    run "md "+shadow
    @0,0 Clear EOL
endif

if istable("invnumb") = true then
     While (true)
          LOCK "invnumb" PFL
          if retval = true then
                 quitloop
          endif
     EndWhile
else
     MessgBox(10)
endif

if istable(shadow+"\\invoice") = false then
    SetupTable("invoice")
endif
if istable(shadow+"\\custmstr") = false then
    SetupTable("Custmstr")
endif
if istable(shadow+"\\prchdetl") = false then
    SetupTable("Prchdetl")
endif
if istable(shadow+"\\prchmstr") = false then
    SetupTable("Prchmstr")
endif
