Copywrite September 15, 1986 Gregory B. Salcedo [Para/Docs] "EDITOR3"

The accompanying programs and help/documentation are not to be split and
cannot be duplicated not to exceed $9.00.

This editor and related documents cannot be included in any other package or
system without written permission.  This screen and comments not to be altered
or removed.

This product is intended as ShareWare for all interested Paradox users.  If you
like this product please send $30 to:

                              ParaDocs
                              16553 162nd PL SE
                              Renton, WA  98058

A disk with source code and documentation will be sent to you.  You will be
placed on our mailing list for updates and other ParaDocs products.



EDITOR3




EDITOR3 is a system which supplements PAL's editor functions.  Other
editors can be used, but this editing supplement allows you to stay
entirely in Paradox 3 or greater and also allows you to work in more than just
the Script mode of Paradox.

EDITOR3 and GO_EDIT3 are written entirely in PAL.  Your
suggestions on changes and additional features are heartily welcome!  We
have tried to take caution to not be a "memory hog" with this system
so that developers can produce their products and keep EDITOR3 working
in the background.  We suggest that you "RELEASE PROCS ALL RELEASE VARS
ALL RESET" if you wish to do "true" tests of your systems or if you
appear to not have sufficient memory to complete your program.

To INSTALL EDITOR3 please perform the following steps:

1) Copy the enclosed disk to your Paradox directory on your hard drive.

2) Next, get into Paradox 3.5.

3) Run SETEDIT3.

"SETEDIT3" will ask you which directory your EDITOR3 resides.  It will
default to your current directory.  Enter the location of EDITOR3 as
appropriate.  EDITOR3 will then start up.

4) Press [Esc] to return to Paradox Main Mode.

EDITOR3 has now been loaded and will "popup" by simply pressing
[Alt][F1] simultaneously.

EDITOR3 works in the Script, Form and Report Modes mostly.  PRINT and
MINISCRIPT will work in almost all environments.

Once you've installed EDITOR3 it is at your service anytime your
current Paradox session is running.  Once installed you simply
call EDITOR3 from any directory you are currently working in.
Simply do a "Menu {SCRIPTS} {PLAY} dospath\GO_EDIT3" and answer EDITOR3
and tell it where which directory to make its calls from (where it's
located, press [Enter].  Now EDITOR3 will "popup" anytime you press
[Alt][F1] simultaneously.

Explanation of functions and keys:

Drawing Functions

Line:               You may choose Single, Double
                    or any other ASCII character
                    by using [Alt] + 176 =  for
                    example (see your PAL Users
                    Guide.

                    Start Drawing by pressing
                    your arrow keys. Press your
                    [Enter] key < to stop.

                    Depending on whether you have
                    chosen SINGLE or DOUBLE or
                    OTHER you can connect lines
                    by pressing the following:

                    [F3] =  or  [F4] =  or 
                    [F5] =  or  [F6] =  or 
                    [F7] =  or 

Box:                You may draw a box with
                    single, double or any other
                    ASCII character. (See your
                    PAL Users Guide)

                    Move to the upper left-hand
                    corner of where you wish to
                    start your box and press [F6]

                    Next move to the lower right-
                    hand corner of where you wish
                    your box to stop and press
                    [F6] again.

ASCII:              ASCII is a reference of the
                    ASCII codes from 1 to 255
                    and what characters will
                    result from typing in the
                    ASCII code number.

                    For Example: A left arrow
                    can be entered in as
                    typein "\017\196"

Block Operations


Copy:               CopyArea allows you to copy
                    in a Script,Form or Report.
                    You can even copy screens
                    from your PAL scripts to your
                    reports or from the headings
                    from one report to another
                    table with a totally differ-
                    nt structure.  First move to
                    the upper left-hand corner
                    of the area you wish to copy
                    press [F6].

                    Now move to the lower right-
                    hand corner of the area you
                    wish to copy and press press
                    [F6] again. Finally, move to
                    the starting point of where
                    you wish to copy to and press
                    [F6].

Paste
                    Paste allows you to paste a
                    previously copied area into
                    FORM, REPORT or SCRIPT.

                    For example: You can create
                    a FORM in the Form Designer,
                    use COPY and then PASTE it
                    into the Report Generator
                    to avoid rekeying the form.

Search and Replace

Replace:            Search allows you to find any
                    set of characters and replace
                    them with another

                    Warning--DO NOT REPLACE A SET
                    AS FOLLOWS:
                      Search for: thisvar
                    Replace with: thisvarx
                    YOU'LL BE IN AN ENDLESS LOOP

                    Suggestion: Make two passes.
                    First replace 'thisvar' with
                    'xxxxx' then replace 'xxxxx'
                    with thisvarx.

File:               File allows you to save a
                    script without exiting to the
                    Paradox Main mode.  It can
                    also be used for a snapshot
                    of a FORM or REPORT.  (Use
                    print and choose FILE if you
                    are trying to document a your
                    system).

Print:              Print allows you to print the
                    current SCRIPT,FORM or REPORT
                    to the printer or to a file.

                    You may choose to print with
                    or without numbers.  This
                    scripts assumes that you have
                    and IBM Proprinter or compat-
                    ible.

Special Keys:       This selection allows you to
                    place ASCII charracters below
                    ASCII Code 32 on a FORM,
                    SCRIPT or REPORT.

                     Right =  Right Arrow = 
                     Left  =  Left Arrow  = 
                     Up    =  Down        = 

Quit:                 ************************
                      * This choice QUITS    *
                      * EDITOR3 and releases *
                      * its memory.          *
                      ************************

