;ͻ
;        Type Script   Procedure   Library  x Comments   Revision  
;͹
; Name                                 editor2                           
;͹
; Created      09/15/86  Developed by: gbs                                  
;͹
; Revised      08/02/87    Revised by: gbs                                  
;͹
; Added Search and Replace                                                    
;                                                                             
;ͼ
;Copywrite September 15, 1986 Gregory B. Salcedo [ParaDocs] "EDITOR2"
;
;The accompanying programs and help/documentation are not to be split and
;cannot be duplicated not to exceed $9.00.
;
;This editor and related documents cannot be included in any other package or
;system without written permission.  This screen and comments not to be altered
;or removed.
;
;This product is intended as ShareWare for all interested Paradox users.  If you
;like this product please send $45 to:
;
;                              ParaDocs
;                              1020 Woodglen Ct
;                              Stockton,CA 95209
;
;                              Telephone 209-952-0460
;
;A disk with source code and documentation will be sent to you.  You will be
;placed on our mailing list for updates and other ParaDocs products.

Style Attribute 192

@23,0 Clear EOL ?? "Compiling EDITOR2 ..."

createlib "editor2"

proc editormenu()
echo normal
setkey "F31" readlib editorpath+"editor2" editormenu editormenu()
setkey "F32" readlib editorpath+"editor2" CopyAgain CopyAgain()

while (true)

no_items = 11
maxlevel = 4

; this sets up all the menu choices and the corresponding messagess
;        x[n] = the x coordinates
;        c[n] = menu items (the possible choices)
;        d[n] = descriptions of the menu items
;       SC[n] = "top bar" representation of menu item
;       SD[n] = "top bar"      "         "   "     "  description
;     NICK[n] = first letter of menu items

Array         X[no_items]
Array         C[no_items]
Array         D[no_items]
Array        SC[no_items]
Array        SD[no_items]
Array      NICK[no_items]

; These are the menu choices and the corresponding "wide" bar (top) display.


C[1] = "Line"             D[1]  = "Draw a line"
C[2] = "Box"              D[2]  = "Draw a box"
C[3] = "Reference"        D[3]  = "Chart of drawing characters"
C[4] = "CopyLine"         D[4]  = "Copy a line"
C[5] = "MoveLine"         D[5]  = "Move a line"
C[6] = "CopyArea"         D[6]  = "Copy Area"
C[7] = "Search"           D[7]  = "Search and replace"
C[8] = "File"             D[8]  = "Save the current script"
C[9] = "Print"            D[9]  = "Print the Script,Report or Screen"
C[10] = "MiniScript"      D[10] = "Prototype a PAL Script"
C[11] = "Quit"            D[11] = "Quit the EDITOR"


; this menu should appear on the right and so it is hard coded as level 4

level = 4

; B is a variable which establishes where the "left-hand" border appears of the
; bar menu. It is actually the "y" of the @x,y expression.
;
; M is a vairable which established where the message within the bars appears.
; It is actually the "y" of the @x,y expression.
;

B = 51
m = 52


if isassigned(n) = false then
    n = 1
else
    n = n
endif

last = arraysize(c)

; This sets up the ability to graphically display the present menu level.


autolib = editorpath+"editor2"

Barmenu()

if sel = "Esc" then
     @24,0 Clear EOL ?? format("w79,ac","One moment please ...")
     level = level - 1
     quitloop
else


switch

case sel = c[1] :

n = 1

@0,0 Clear EOL
@1,0 Clear EOL

@0,0 ?? "Which charcter ? [S]ingle [D]ouble or [O]ther [Q]uit "
Accept "A8" Picture "{Single,Double,Other,Quit}" Default "" required to char

@0,0 Clear EOL
@1,0 Clear EOL

if char = "Quit" then
   loop
endif


if char = "Single" then
         xul = ""   xur = ""   xll = ""   xlr = ""
       hchar = ""   con1 = "" con2 = "" con3 = ""
       vchar = ""   con4 = "" con5 = ""
endif

if char = "Double" then
         xul = ""   xur = ""   xll = ""   xlr = ""  xfill = ""
       hchar = ""  con1 = "" con2 = "" con3 = ""
       vchar = ""  con4 = "" con5 = ""
endif

if char = "Other" then
       @0,20 Clear EOL ?? "Which charcter "
       Accept  "A8" Default "" required to char

         xul = char  xur = char  xll = char  xlr = char xfill = char
       hchar = char  con1 = char  con4 = char
       vchar = char  con2 = char  con5 = char
       ochar = char  con3 = char
endif
                  dragline()


case sel = c[3] : n = 3
                  editor_ref()

case sel = c[4] : n = 4
                  copyline()

case sel = c[2] :

n = 2
@0,0 Clear EOL
@1,0 Clear EOL

@0,0 ?? "Which charcter ? [S]ingle [D]ouble or [O]ther [Q]uit "
Accept "A8" Picture "{Single,Double,Other,Quit}" Default "" required to char

@0,0 Clear EOL
@1,0 Clear EOL

if char = "Quit" then
   loop
endif


if char = "Single" then
         xul = ""   xur = ""   xll = ""   xlr = ""
       hchar = ""   con1 = ""  con2 = "" con3 = ""
       vchar = ""   con4 = ""  con5 = ""
endif

if char = "Double" then
         xul = ""   xur = ""   xll = ""   xlr = ""  xfill = ""
       hchar = ""   con1 = "" con2 = "" con3 = ""
       vchar = ""   con4 = "" con5 = ""
endif

if char = "Other" then
       @0,20 Clear EOL ?? "Which charcter "
       Accept  "A8" Default "" required to char

         xul = char  xur = char  xll = char  xlr = char xfill = char
       hchar = char  con1 = char con2 = char con3 = char
       vchar = char  con4 = char con5 = char
       ochar = char
endif
                  drag_box()

case sel = c[5] : n = 5
                  moveline()

case sel = c[6] : n = 6
                  CopyArea()

case sel = c[7] : n = 7
                  Srch_Rpl()

case sel = c[8] : n = 8
                  SaveScript()

case sel = c[9] : n = 9
                  PrintIt()

case sel = c[10] : n = 10
                   MiniSC()

case sel = c[11] : n = 11
                  quitloop

EndSwitch
endif

quitloop
endwhile

endproc

;copyline is a procedure that copies an entire or portion of a line to any
;place in a SCRIPT, FORM or REPORT

proc copyline ()

setkey "F17" lin = substr(cursorline(),colno(),len(cursorline()))
setkey "F18" typein lin
endproc

;moveline is a procedure that first copies an entire or postion of a line,
;delete what is copies and then places it anywhere in a SCRIPT, FORM or REPORT

proc moveline ()

setkey "F19" lin = substr(cursorline(),colno(),len(cursorline())) Deleteline
setkey "F20" CtrlHome Enter typein lin

endproc

proc copyarea()
@0,0 Clear EOL
@1,0 Clear EOL


;echo normal

if sysmode() = "Script" or sysmode() = "Report" or sysmode() = "Form" then

   if isinsertmode() = true then
      @0,0 Clear EOL ?? "INSERT MODE ACTIVE ... TURN OFF ? y/n "
      Accept "A1" Picture "{Y,y,N,n}" required default "" to answer
          if answer = "Y" or answer = "y" then
             Ins
          endif
   endif


@0,0 Clear EOL ?? "Move to upper left hand corner of the area to COPY FROM and press [F6]"

r1 = 0
r2 = 0
c1 = 0
c2 = 0

editorit = 0

While true
gc = getchar()
      if gc = asc("F1") then
           Readlib editorpath+"EditHelp" HelpEdit HelpEdit()
           gc = ""
           Echo Normal
           Right Left
           loop
      endif

     if gc = asc("F6") and editorit = 0 then
        r1 = rowno()
        c1 = colno()
        editorit = editorit + 1
        @0,0 Clear EOL ?? "Move to lower right hand corner of the area to COPY FROM and press [F6]"
        loop
     endif
     if gc = asc("F6") and editorit > 0 then
        left
        r2 = rowno()
        c2 = colno()+1
     endif
     if gc = asc("Right") or gc = asc("Left") or gc = asc("CtrlRight") or gc = asc("CtrlLeft") then
          keypress gc
          loop
     endif
     if gc = asc("Up") or gc = asc("Down") or gc = asc("Home") or gc = asc("End") then
          keypress gc
          loop
     endif
     if gc = asc("CtrlHome") or gc = asc("CtrlEnd") then
          keypress gc
          loop
     endif
     if gc = asc("PgUp") or gc = asc("PgDn") then
          keypress gc
          loop
     endif

     if r1 > 0 and r2 > 0 then

          getup = 0
         goback = 0
          width = abs(c1 - c2)
         length = abs(r1 - r2)

     Array Lin[length+1]


     for getup  from 1 to length step 1 up   endfor
     for goback from 1 to  width  step 1 left endfor

          Counter = 0

           direct = 0

     for counter from 1 to length+1 step 1
              start = c1
     if len(cursorline()) > 0 then
        if c1 = 1 then
           if len(cursorline()) = 1 then
               checklength = substr(cursorline(),c1,1) ;made the chg here
           else
               checklength = substr(cursorline(),c1,len(cursorline())-c1)
           endif
        else
           if len(cursorline()) < c1 then
              checklength = ""
           else
              checklength = substr(cursorline(),c1,len(cursorline())-c1)
           endif

        endif
     else
        checklength = ""
     endif

     stop = Min(len(cursorline())-c1+1,width+1)

     if len(cursorline()) = 0 then

         Lin[Counter]  = fill(" ",width)

     else

         if len(cursorline()) < c1 then
             Lin[Counter] = " "
         else
             Lin[Counter] = substr(cursorline(),c1,stop) ; change here
         endif

     endif

     down

     endfor
     quitloop
     endif

quitloop
endwhile
@0,0 Clear EOL ?? "Move to upper left hand corner of the area to COPY TO and press [F6]"

editorit = 0

While true
gc = getchar()
     if gc = asc("F1") then
          Readlib editorpath+"EditHelp" HelpEdit HelpEdit()
          gc = ""
          Echo Normal
          Right Left
          loop
     endif
     if gc = asc("F6") and editorit = 0 then
        r1 = rowno()
        c1 = colno()
        editorit = editorit + 1
     endif
     if gc = asc("Right") or gc = asc("Left") then
          keypress gc
          loop
     endif
     if gc = asc("CtrlHome") or gc = asc("CtrlEnd") then
           keypress gc
           loop
     endif
     if gc = asc("Home") or gc = asc("End") then
          keypress gc
          loop
     endif
     if gc = asc("CtrlRight") or gc = asc("CtrlLeft") then
          keypress gc
          loop
     endif
     if gc = asc("Up") or gc = asc("Down") then
          keypress gc
          loop
     endif
     if gc = asc("PgUp") or gc = asc("PgDn") then
          keypress gc
          loop
     endif

     if editorit > 0 then

          getup = 0
         goback = 0

          Counter = 0

           direct = 0

     for counter from 1 to length+1 step 1

     typein lin[counter]

     for direct  from 1 to len(lin[counter]) step 1 left endfor

     down

     endfor

     endif

quitloop
endwhile


else

Message "cannot copy in this enviroment" beep beep beep sleep 500
Clear

endif

echo off

endproc


proc dragline()



echo normal

if sysmode() = "Script" or sysmode() = "Report" or sysmode() = "Form" then

@0,0 Clear EOL ?? "Press Arrow Keys to Start editoring -\016  \017-"

Array Ch[5]
Array Mesg[5]

;mssg = "Press \017 to switch characters"


Ch[1] = con1
Ch[2] = con2
Ch[3] = con3
Ch[4] = con4
Ch[5] = con5

While true
gc = getchar()
     if gc = asc("Enter") then
         quit
     else
         if gc = asc("F1") then
              Readlib editorpath+"EditHelp" HelpEdit HelpEdit()
              gc = ""
              Echo Normal
              Right Left
         endif

         if gc = asc("F3") then
              yy = Ch[1]
              typein yy
             ;left down
         endif
         if gc = asc("F4") then
              yy = Ch[2]
              typein yy
              left down
         endif
         if gc = asc("F5") then
               yy = Ch[3]
               typein yy
               left down
         endif
         if gc = asc("F6") then
                yy = Ch[4]
                typein yy

         endif
         if gc = asc("F7") then
                yy = Ch[5]
                typein yy
                left down
         endif
         if gc = asc("Right") or gc = asc("Left") then
              if char = "Other" then
                   yy = ochar
              else
                   yy = hchar
              endif

              execute "\"" + yy + "\""

              if gc = asc("Left") then
                       left left
              endif

         endif

         if gc = asc("Up") or gc = asc("Down") then
             if char = "Other" then
                   yy = ochar
             else
                   yy = vchar
             endif
             execute "\"" + yy + "\""
             left
             keypress gc
        endif
        loop
     endif
quitloop
endwhile

else

Message "cannot editor in this enviroment" beep beep beep sleep 500
Clear

endif

endproc

proc drag_box()

echo normal

if sysmode() = "Script" or sysmode() = "Report" or sysmode() = "Form" then

   if isinsertmode() = true then
       @0,0 Clear EOL ?? "INSERT MODE ACTIVE ... TURN OFF ? y/n "
       Accept "A1" Picture "{Y,y,N,n}" required default "" to answer
           If answer = "Y" or answer = "y" then
              Ins
           endif
   endif

@0,0 Clear EOL ?? "Move to upper left hand corner of box press [F6]"

r1 = 0
r2 = 0
c1 = 0
c2 = 0
editorit = 0

While true
gc = getchar()
      if gc = asc("F1") then
           Readlib editorpath+"EditHelp" HelpEdit HelpEdit()
           gc = ""
           Echo Normal
           Right Left
           loop
      endif
     if gc = asc("F6") and editorit = 0 then
          yy = "\016"
          r1 = rowno()
          c1 = colno()
          editorit = editorit + 1
          execute "\"" + yy + "\""
          @0,0 Clear EOL ?? "Move to lower right hand corner and press [F6]"
          loop
     endif
     if gc = asc("F6") and editorit > 0 then
        yy = "\017"
        execute "\"" + yy + "\""
        left
        r2 = rowno()
        c2 = colno()
     endif
     if gc = asc("Right") or gc = asc("Left") or gc = asc("CtrlRight") or gc = asc("CtrlLeft") then
          keypress gc
          loop
     endif
     if gc = asc("Up") or gc = asc("Down") or gc = asc("Home") or gc = asc("End") then
          keypress gc
          loop
     endif
     if gc = asc("CtrlHome") or gc = asc("CtrlEnd") then
          keypress gc
          loop
     endif
     if gc = asc("PgUp") or gc = asc("PgDn") then
          keypress gc
          loop
     endif

     if r1 > 0 and r2 > 0 then

          getup = 0
         goback = 0
          width = abs(c2 - c1)
         length = abs(r2 - r1)

     for getup  from 1 to length step 1 up   endfor
     for goback from 1 to width step 1 left endfor
         upline = xul + fill(hchar,width-1) + xur

        lowline = xll + fill(hchar,width-1) + xlr


        Counter = 0

      execute "\"" + upline + "\""

           direct = 0

           For direct From 1 to goback  Step 1 left endfor
               Down

           ;direct = 0

           For counter

                     From 1 TO length - 1 step 1

                       execute "\"" + vchar + "\""

                           for direct from 1 to goback-2 step 1 right endfor

                       execute "\"" + vchar + "\""

                          for direct from 1 to goback step 1 left endfor

         down

         endfor

         Execute "\"" + lowline + "\""

     quitloop
     endif

quitloop
endwhile


else

Message "cannot editor in this enviroment" beep beep beep sleep 500
Clear

endif

endproc

proc editor_ref ()

Style Attribute 48
@ 2,0
Text
[   Control + Function Key    ]
ͻ ͻ
           F1 F2      
  Select   ͹ ͹
    a      F3 F4      
 Character ͹ ͹
           F5 F6  -  -
[Ctrl]+[Fn]͹ ͹
           F7 F8      
           ͹ ͹
           F9 F10       
ͼ ͼ
Endtext

setkey "F21" "\016"            ; this is the character      
setkey "F22" "\017"            ; this is the character      
setkey "F23" "\030"            ; this is the character      
setkey "F24" "\031"            ; this is the character      
setkey "F25" "-"              ; this are the characters    -
setkey "F26" "-"              ; this are the characters    -
setkey "F27" ""              ; this is the character      

message "press any key to continue ..."
gc = getchar()

endproc


;ͻ
;        Type Script   Procedure x Library    Comments   Revision  
;͹
; Name                    srch_rpl                                       
;͹
; Created      09/15/86  Developed by: gbs                                  
;͹
; Revised      02/14/87    Revised by: gbs                                  
;͹
;                                                                             
;                                                                             
;ͼ

Style Attribute 192

proc srch_rpl()
echo off

While (true)
findthis = ""
Replthis = ""
Style attribute 79
@0,0 Clear EOL
@1,0 Clear EOL
@0,0 ?? "Search for ?     "
Accept "A40"  Default findthis to FindThis

if retval = "Esc" then
     quitloop
endif
if findthis = "" then
     quitloop
endif
Style Attribute 48

@1,0 ?? "Replace with ?   "
Accept "A40"  Default ReplThis to ReplThis

if retval = "Esc" then
     quitloop
endif

checkthis = len(findthis) - len(replthis)

if sysmode() = "Script" or sysmode() = "Report" or sysmode() = "Form" then

   @24,0 Clear EOL ?? "Continue y/n ?"
   Accept "A1" picture "{Y,y,n,N}" required default "y" to answer

   @24,0 Clear EOL

   if answer = "n" or answer = "N" then
        quitloop
   endif


   if isinsertmode() = true then
      @0,0 Clear EOL ?? "INSERT MODE ACTIVE ... TURN OFF ? y/n "
      Accept "A1" Picture "{Y,y,N,n}" required default "" to answer
          if answer = "Y" or answer = "y" then
               Ins
          endif
   endif

   here = 0
counter = 0
repllen = 0
 begrow = 0
stoprow = 0
looklen = 0
   here = rowno()
foundit = 0
Home
begrow  = rowno()
End
stoprow = rowno()

Home
repllen = len(FindThis)

for counter from 1 to stoprow step 1
      lookatit = cursorline()
       looklen = len(lookatit)

          While search(findthis,lookatit)  > 0
           foundit = foundit + 1
          lookatit = cursorline()
           looklen = len(lookatit)
               if search(findthis,lookatit)  > 0 then
                  start = search(findthis,lookatit)

                  if start > 1 then
                     front = substr(lookatit,1,start-1)
                  else
                     front = ""
                  endif

                  if repllen < looklen and len(cursorline()) > start + repllen then
                     back  = substr(lookatit,start+repllen,looklen-(start+repllen-1)) ;here was -1
                  else
                     back  = ""
                  endif

                  lookatit = front + replthis + back
                  CtrlHome
                  typein lookatit

                  if checkthis > 0 then
                  DeleteLine
                  endif

                  loop
                endif
           down
           quitloop
           EndWhile
down
endfor

Style Intense
@2,0 Clear EOL
Style Reverse
@24,0 Clear EOL ?? Format("W50,AL","Number of succesful replaced strings = " + format("w4,EZ",foundit)) + " ... press any key"
gc = getchar()
style
Clear

CtrlHome

for counter from 1 to stoprow-1 step 1
up
endfor
else
message "Cannot edit in this enviroment"
beep
endif

quitloop
endwhile
echo normal
endproc


Proc SaveScript ()
While (true)
@0,0 Clear EOL
@1,0 Clear EOL

@0,0 Clear EOL ?? "Script name = "
Accept "A8" required to scriptname

if isfile(scriptname+".sc") = true then
     @0,0 Clear EOL ?? "File exists ... [E]rase or [S]tart over ? "
      Accept "a1" picture "{S,s,E,e}" required default "S" to answer
     @0,0 Clear EOL
          if answer = "E" then
              run "erase " + scriptname + ".sc"

         else
              loop
         endif
endif

@0,0 Clear EOL ?? "Save this script as  " + scriptname + "  Yes/No ? "
Accept "a3" picture "{Yes,No}" required default "Yes" to answer
@0,0 Clear EOL ?? "Saving "
Style Blink ?? "..."
Style

if answer = "No" then
     quitloop
endif

Home
start = rowno()
end
stop  = rowno()
counter = 0
home
scriptname = scriptname + ".sc"
for counter from start to stop step 1
    print file scriptname  cursorline(),"\n"
    down
endfor
for counter from 1 to stop-1 step 1
up
endfor
@0,0 Clear EOL
quitloop
endwhile

endproc

Proc BarMenu()

if isassigned(s) = false then
     if isfile("savevars.sc") = true then
           play "savevars"
     else
           s = 31
     endif
endif

if isassigned(s) = false then
     s = 31
endif


style attribute s

        C[1] = format("w15,al",c[1])
       SC[1] = format("w79,al",c[1])
       SD[1] = format("w79,al",d[1])
     NICK[1] = substr(c[1],1,1)
        X[1] = 3
              @x[1],B ?? "ͻ"
            @x[1]+1,B ?? "               "
            @x[1]+1,m ?? c[1]
        C[2] = format("w15,al",c[2])
       SC[2] = format("w79,al",c[2])
       SD[2] = format("w79,al",d[2])
     NICK[2] = substr(c[2],1,1)
        X[2] = 4
            @x[2]+1,B ?? "               "  ;
            @x[2]+1,m ?? c[2]
        C[3] = format("w15,al",c[3])
       SC[3] = format("w79,al",c[3])
       SD[3] = format("w79,al",d[3])
     NICK[3] = substr(c[3],1,1)
        X[3] = 5
            @x[3]+1,B ?? "               "  ;
            @x[3]+2,B ?? "͹"  ;
            @x[3]+1,m ?? c[3]
        C[4] = format("w15,al",c[4])
       SC[4] = format("w79,al",c[4])
       SD[4] = format("w79,al",d[4])
     NICK[4] = substr(c[4],1,1)
        X[4] = 7
            @x[4]+1,B ?? "               "  ;
            @x[4]+1,m ?? c[4]
        C[5] = format("w15,al",c[5])
       SC[5] = format("w79,al",c[5])
       SD[5] = format("w79,al",d[5])
     NICK[5] = substr(c[5],1,1)
        X[5] = 8
            @x[5]+1,B ?? "               "  ;
            @x[5]+1,m ?? c[5]
        C[6] = format("w15,al",c[6])
       SC[6] = format("w79,al",c[6])
       SD[6] = format("w79,al",d[6])
     NICK[6] = substr(c[6],1,1)
        X[6] =  9
            @x[6]+1,B ?? "               "  ;
            @x[6]+2,B ?? "͹"  ;
            @x[6]+1,m ?? c[6]
        C[7] = format("w15,al",c[7])
       SC[7] = format("w79,al",c[7])
       SD[7] = format("w79,al",d[7])
     NICK[7] = substr(c[7],1,1)
        X[7] =  11
            @x[7]+1,B ?? "               "  ;
            @x[7]+1,m ?? c[7]
        C[8] = format("w15,al",c[8])
       SC[8] = format("w79,al",c[8])
       SD[8] = format("w79,al",d[8])
     NICK[8] = substr(c[8],1,1)
        X[8] =  12
            @x[8]+1,B ?? "               "  ;
            @x[8]+1,m ?? c[8]
        C[9] = format("w15,al",c[9])
       SC[9] = format("w79,al",c[9])
       SD[9] = format("w79,al",c[9])
     NICK[9] = substr(c[9],1,1)
        X[9] = 13
            @x[9]+1,B ?? "               "
            @x[9]+1,m ?? c[9]
        C[10]= format("w15,al",c[10])
       SC[10]= format("w79,al",c[10])
       SD[10]= format("w79,al",c[10])
     NICK[10]= substr(c[10],1,1)
        X[10]= 14
            @x[10]+1,B ?? "               "
            @x[10]+1,m ?? c[10]
        C[11] = format("w15,al",c[11])
       SC[11] = format("w79,al",c[11])
       SD[11] = format("w79,al",c[11])
     NICK[11] = substr(c[11],1,1)
        X[11] = 15
            @x[11]+1,B ?? "               "
            @x[11]+2,B ?? "͹"
            @x[11]+1,m ?? c[11]

         @x[last]+3,B ?? "   [F1] HELP   "  ;
         @x[last]+4,B ?? "ͼ"  ;

While (true)

; The following dsiplays the menu item and description as top bars
; and highlights the item in the bar menu.

style reverse          @0,0 ?? SC[n]
style Attribute S      @1,0 ?? SD[n]
style reverse     @x[n]+1,m ?? c[n]

; wait for the "user" to type a letter

gc = getchar()

; evaluate the character and perform based on which charcter was chosen

Switch

CASE gc = -59 : HelpZoom()
                loop

CASE gc >= 48 and gc <= 122 : SubMenu()
                              sel =  sel
                              quitloop
CASE gc = 27 :
              sel = "Esc"
              quitloop

CASE gc = 13 :
              sel = c[n]
              quitloop

CASE gc = -71:                          ; Home key is pressed
              Style attribute s
              @x[n]+1,m ?? c[n]
              n = 1
              loop

CASE gc = -79:                          ; End key is pressed
              Style attribute s
              @x[n]+1,m ?? c[n]
              n = last
              loop

CASE gc = -72:                          ; Up key is pressed
              if n = 1 then
                   Style attribute s
                   @x[n]+1,m ?? c[n]
                   n = last
                   loop
              else
                   Style attribute s
                   @x[n]+1,m ?? c[n]
                   n = n - 1
                   loop
              endif

CASE gc = -80:                          ; Down key is pressed
              if n = last then
                   Style Attribute s
                   @x[n]+1,m ?? c[n]
                   n = 1
                   loop
              else
                   Style Attribute s
                   @x[n]+1,m ?? c[n]
                   n = n + 1
                   loop
              endif

EndSwitch

Reset
ClearAll
;quitloop
Endwhile


; end of BarMenu
endproc

Proc HelpZoom()

Readlib editorpath+"EditHelp" HelpEdit HelpEdit()

Bar()

endproc


Proc Bar()

style attribute s
              @x[1],B ?? "ͻ"
            @x[1]+1,B ?? "               "
            @x[1]+1,m ?? c[1]
            @x[2]+1,B ?? "               "  ;
            @x[2]+1,m ?? c[2]
            @x[3]+1,B ?? "               "  ;
            @x[3]+2,B ?? "͹"  ;
            @x[3]+1,m ?? c[3]
            @x[4]+1,B ?? "               "  ;
            @x[4]+1,m ?? c[4]
            @x[5]+1,B ?? "               "  ;
            @x[5]+1,m ?? c[5]
            @x[6]+1,B ?? "               "  ;
            @x[6]+2,B ?? "͹"  ;
            @x[6]+1,m ?? c[6]
            @x[7]+1,B ?? "               "  ;
            @x[7]+1,m ?? c[7]
            @x[8]+1,B ?? "               "  ;
            @x[8]+1,m ?? c[8]
            @x[9]+1,B ?? "               "
            @x[9]+1,m ?? c[9]
            @x[10]+1,B ?? "               "
            @x[10]+1,m ?? c[10]
            @x[11]+1,B ?? "               "
            @x[11]+2,B ?? "͹"
            @x[11]+1,m ?? c[11]
          @x[last]+3,B ?? "   [F1] HELP   "  ;
          @x[last]+4,B ?? "ͼ"  ;

endproc


Proc SubMenu()

While (true)
Array submA[last]
Array submB[last]

if gc > 90 then
     gc = gc - 32
endif

countit = 0

for look from 1 to last step 1
    if asc(nick[look]) = gc then
          n = look
          countit = countit + 1
          subma[countit] = c[look]
          submB[countit] = d[look]
    endif
endfor

if isassigned(subma[1]) = false then
      quitloop
endif

if countit = 1 then
      Bar()
style reverse          @0,0 ?? SC[n]
style Attribute S      @1,0 ?? SD[n]
style reverse     @x[n]+1,m ?? c[n]


      sel = subma[countit]
      quitloop
endif
Array SubA[countit]
Array SubB[countit]

for assign from 1 to countit
        suba[assign] = subma[assign]
        subb[assign] = submb[assign]
        Bar()
style reverse          @0,0 ?? SC[n]
style Attribute S      @1,0 ?? SD[n]
style reverse     @x[n]+1,m ?? c[n]
endfor


showarray
          subA subB

to sel
quitloop
endwhile
endproc

Proc GetFields()
Private gc

if istable(z) = true then

     Menu {Tools} {Info} {Structure} select z
     nn = nrecords("struct")
     Array Names[nn]
     Array Types[nn]
     moveto[field name]

     for counter from 1 to nn step 1
            Names[counter] = []
            Types[counter] = [Field Type]
            Down
     endfor
else
     message "Table ",z," does not exist ... press any key"
     gc = getchar()
endif
endproc


Proc CopyAgain()
     if arraysize(lin) > 0 then
         for counter from 1 to arraysize(lin) step 1
               typein lin[counter]
               for direct from 1 to len(lin[counter]) step 1 left endfor

               down
         endfor

     else
         message "Nothing to copy ..."
         sleep 1000
     endif
endproc


Proc PrintIt()
scriptname = ""

While (true)
@0,0 Clear EOL
@1,0 Clear EOL

@0,0 Clear EOL ?? "Print to Printer or File ? "
Accept "a7" picture "{Printer,File}" required default "Printer" to device

if device =  "Printer" then

While (true)
      if printerstatus() = true then
          quitloop
      else
          @24,0 Clear EOL "Printer Not Ready ..."
          loop
      endif
EndWhile

endif

@0,0 Clear EOL ?? "Print Line Numbers ? "
Accept "a3" picture "{Yes,No}" required default "Yes" to numbans


if device = "File" then
     @0,0 Clear EOL ?? "File name = "
     Accept "A8" required to scriptname
endif

if isassigned(scriptname) = true then

if isfile(scriptname+".sc") = true then
     @0,0 Clear EOL ?? "File exists ... [E]rase or [S]tart over ? "
     Accept "a1" picture "{S,s,E,e}" required default "S" to answer
     @0,0 Clear EOL
          if answer = "E" then
              run "erase " + scriptname + ".sc"
         else
              loop
         endif
endif

endif

@0,0 Clear EOL ?? "Continue with printing ...  Yes/No ? "
Accept "a3" picture "{Yes,No}" required default "Yes" to answer
@0,0 Clear EOL ?? "Saving "
Style Blink ?? "..."
Style

if answer = "No" then
     quitloop
endif

Home
start = rowno()
end
stop  = rowno()
counter = 0
home
scriptname = scriptname + ".sc"

if numbans = "No" then
if device = "File" then

for counter from start to stop step 1
    print file scriptname  cursorline(),"\n"
    down
endfor
for counter from 1 to stop-1 step 1
up
endfor

else
print "\015" ;sets up condensed
print "\f"

for counter from start to stop step 1
    print cursorline(),"\n"
    down
endfor
for counter from 1 to stop-1 step 1
up
endfor
endif
endif

if numbans = "Yes" then
if device = "File" then

for counter from start to stop step 1
    linen = strval(counter)
    if counter <= 9 then
          linen = "0" + linen
    endif
    print file scriptname  linen," ",cursorline(),"\n"
    down
endfor
for counter from 1 to stop-1 step 1
up
endfor

else
print "\015" ;sets up condensed
print "\f"

for counter from start to stop step 1
    linen = strval(counter)
    if counter <=9 then
          linen = "0" + linen
    endif

    print linen," ",cursorline(),"\n"
    down
endfor
for counter from 1 to stop-1 step 1
up
endfor
endif
endif

@0,0 Clear EOL
quitloop
endwhile

endproc

Proc MiniSC()
ErrorProc = "HandleMini"
if isassigned(miniline1) = true then
     miniline1 = miniline1
else
     miniline1 = " "
endif
if isassigned(miniline2) = true then
     miniline2 = miniline2
else
     miniline2 = " "
endif


q = "\""
@0,0 Clear EOL ?? "You have 132 characters to build your MiniScript. It will be saved under the "
@1,0 Clear EOL ?? "scriptname MINISC ... you can READ it from there.. press any key.            "
gc = getchar()

@1,0 Clear EOL
@0,0 Clear EOL ?? "New or edit last MiniSc [New,Edit] ? "
Accept "a4" picture "{New,Edit}" required default "New" to answer

if answer = "New" then
     miniline1 = " "
     miniline2 = " "
endif


@0,0 Clear EOL ??
Accept "a75" default miniline1 to miniline1
@1,0 Clear EOL ??
accept "a57" default miniline2 to miniline2

if isfile("Minisc.sc") = true then
     run "erase minisc.sc"
endif

Print file "minisc.sc" miniline1,"\n"
Print file "minisc.sc" miniline2,"\n"

tryit = miniline1+miniline2

TryMini()

endproc

Proc TryMini()

Errorproc = "HandleMini"

execute tryit

endproc

Proc HandleMini()
     Private Errorproc
     if errorcode() > 0 then
          msg = errormessage()
     @24,0 Clear EOL ?? "Error in MiniScript " + msg
     gc = getchar()
     @0,0 Clear EOS
     Echo Normal
     Right Left
     endif

endproc


Style
@23,0 Clear EOL
Clear
writelib "editor2" copyline,moveline,editor_ref,dragline,drag_box,editormenu,
                   copyarea, srch_rpl, SaveScript,BarMenu,Bar,SubMenu,HelpZoom,
                   GetFields,CopyAgain,PrintIt,MiniSC,HandleMini,TryMini
