;EditorLib = "Editor3"
CreateLib EditorLib

Style Attribute 192
@24,0 Clear EOL ?? "Compiling Editor_Menu..."

proc closed Editor_Menu()
usevars editorlib

while (true)

ShowMenu
               "Draw" : "Draw a LINE or BOX",
              "ASCII" : "Reference ASCII Chart and place ASCII characters",
              "Block" : "Block operations, COPY, MOVE & PASTE",
            "Replace" : "Search & Replace",
               "File" : "Save current script",
              "Print" : "Print current script",
  "Special Characters":"Place a special ASCII character",
              "Quit"  : "Quit EDITOR 3 and release memory"

          Until "F1"
          keyto keyvar
          to editorsel

          if keyvar = "F1" then
               helpsub = editorsel
               ReadLib EditorLib Editor_Help
                       Editor_Help(helpsub)
               loop
          endif

          Switch

                   case editorsel = "Draw" :While (true)
                                                ShowMenu
                                                     "Line":"Draw a Line",
                                                     "Box" :"Draw a Box"

                                                       Until "F1"
                                                       keyto keyvar
                                                       to editorsel

                                                       if keyvar = "F1" then
                                                            helpsub = editorsel
                                                            ReadLib EditorLib Editor_Help
                                                                    Editor_Help(helpsub)
                                                            loop
                                                       endif


                                                     Switch
                                                            case editorsel = "Esc"  : quitloop

                                                            case editorsel = "Line" : ReadLib EditorLib Draw_Line
                                                                                      Draw_Line()
                                                                                      Return
                                                            case editorsel = "Box"  : ReadLib EditorLib Draw_Box
                                                                                      Draw_Box()
                                                                                      Return
                                                     EndSwitch

                                             EndWhile
                                             loop
                  case editorsel = "ASCII" : Readlib EditorLib Editor_Ref
                                             Editor_Ref()

                  case editorsel = "Block" : While (true)
                                              ShowMenu
                                                     "Copy" : "Copy Area",
                                                     "Paste": "Paste Area"

                                                       Until "F1"
                                                       keyto keyvar
                                                       to editorsel

                                                       if keyvar = "F1" then
                                                            helpsub = editorsel
                                                            ReadLib EditorLib Editor_Help
                                                                    Editor_Help(helpsub)
                                                            loop
                                                       endif

                                                      Switch
                                                             case editorsel = "Esc" :Quitloop

                                                             case editorsel = "Copy": ReadLib EditorLib Copy_Area
                                                                                      Copy_Area()
                                                                                      Return
                                                             case editorsel = "Paste":Readlib EditorLib Paste_Area
                                                                                      Paste_Area()
                                                                                      Return
                                                      OtherWise:Loop
                                                      EndSwitch
                                             EndWhile
                                             loop
                  case editorsel = "Replace":ReadLib EditorLib Search_Replace
                                             Search_Replace()
                  case editorsel = "File"   :ReadLib EditorLib Save_Script
                                             Save_Script()
                  case editorsel = "Print"  :ReadLib EditorLib Print_It
                                             Print_It()

                  case editorsel = "Special Characters"  :ReadLib EditorLib Special_Char
                                                          Special_Char()


                  case editorsel = "Quit"   :Savevars editorpath,editorlib
                                             Release Vars All
                                             play "savevars"
                                             Return
          OtherWise:Loop

          EndSwitch

quitloop
EndWhile
EndProc

writelib EditorLib Editor_Menu


Style Attribute 192
@24,0 Clear EOL ?? "Compiling Draw_Box()..."


proc closed Draw_Box()

Usevars EditorPath,EditorLib
ReadLib "Editor3" Select_Char
Select_Char()
play "savevars"
echo normal
sysm = sysmode()
if sysm = "Script" or sysm = "Report" or sysm = "Form" then

   if isinsertmode() = true then
       @0,0 Clear EOL ?? "INSERT MODE ACTIVE ... TURN OFF ? y/n "
       Accept "A1" Picture "{Y,y,N,n}" required default "" to answer
           if answer = "Y" or answer = "y" then
                Ins
           endif
   endif

@0,0 Clear EOL ?? "Move to upper left hand corner of box press [F6]"

r1 = 0
r2 = 0
c1 = 0
c2 = 0
editorit = 0

While true
gc = getchar()
      if gc = asc("F1") then
           Readlib editorpath+"EditHelp" HelpEdit HelpEdit()
           gc = ""
           Echo Normal
           Right Left
           loop
      endif
     if gc = asc("F6") and editorit = 0 then
          yy = "\016"
          r1 = rowno()
          c1 = colno()
          editorit = editorit + 1
          execute "\"" + yy + "\""
          @0,0 Clear EOL ?? "Move to lower right hand corner and press [F6]"
          loop
     endif
     if gc = asc("F6") and editorit > 0 then
        yy = "\017"
        execute "\"" + yy + "\""
        left
        r2 = rowno()
        c2 = colno()
     endif
     if gc = asc("Right") or gc = asc("Left") or gc = asc("CtrlRight") or gc = asc("CtrlLeft") then
          keypress gc
          loop
     endif
     if gc = asc("Up") or gc = asc("Down") or gc = asc("Home") or gc = asc("End") then
          keypress gc
          loop
     endif
     if gc = asc("CtrlHome") or gc = asc("CtrlEnd") then
          keypress gc
          loop
     endif
     if gc = asc("PgUp") or gc = asc("PgDn") then
          keypress gc
          loop
     endif

     if r1 > 0 and r2 > 0 then

          getup = 0
         goback = 0
          width = abs(c2 - c1)
         length = abs(r2 - r1)

     for getup  from 1 to length step 1 up   endfor
     for goback from 1 to width step 1 left endfor
         Echo off
         upline = xul + fill(hchar,width-1) + xur

        lowline = xll + fill(hchar,width-1) + xlr


        Counter = 0

        typein upline

           direct = 0

           For direct From 1 to goback  Step 1 left endfor
               Down

           ;direct = 0

           For counter

                     From 1 TO length - 1 step 1

                       typein vchar

                           for direct from 1 to goback-2 step 1 right endfor

                       typein vchar

                          for direct from 1 to goback step 1 left endfor

         down

         endfor

         typein lowline
         Echo Normal
     quitloop
     endif
quitloop
endwhile


else

Message "cannot editor in this enviroment" beep beep beep sleep 500
Clear

endif

endproc

writelib EditorLib Draw_Box


Style Attribute 192
@24,0 Clear EOL ?? "Compiling Draw_Line()..."


Proc Closed Draw_Line()
UseVars EditorLib
ReadLib "Editor3" Select_Char
Select_Char()
play "savevars"
echo normal

SysM = sysmode()

if sysm = "Script" or sysm = "Report" or sysm = "Form" then

@0,0 Clear EOL ?? "Press Arrow Keys to Start editoring -\016  \017-"

Array Ch[5]
Array Mesg[5]

;mssg = "Press \017 to switch characters"


Ch[1] = con1
Ch[2] = con2
Ch[3] = con3
Ch[4] = con4
Ch[5] = con5

While true
gc = getchar()
     if gc = asc("Enter") then
         quit
     else
         if gc = asc("F1") then
              Readlib editorpath+"EditHelp" HelpEdit HelpEdit()
              gc = ""
              Echo Normal
              Right Left
         endif

         if gc = asc("F3") then
              yy = Ch[1]
              typein yy
             ;left down
         endif
         if gc = asc("F4") then
              yy = Ch[2]
              typein yy
              left down
         endif
         if gc = asc("F5") then
               yy = Ch[3]
               typein yy
               left down
         endif
         if gc = asc("F6") then
                yy = Ch[4]
                typein yy

         endif
         if gc = asc("F7") then
                yy = Ch[5]
                typein yy
                left down
         endif
         if gc = asc("Right") or gc = asc("Left") then
              if char = "Other" then
                   yy = ochar
              else
                   yy = hchar
              endif

              execute "\"" + yy + "\""

              if gc = asc("Left") then
                       left left
              endif

         endif

         if gc = asc("Up") or gc = asc("Down") then
             if char = "Other" then
                   yy = ochar
             else
                   yy = vchar
             endif
             execute "\"" + yy + "\""
             left
             keypress gc
        endif
        loop
     endif
quitloop
endwhile

else

Message "cannot editor in this enviroment" beep beep beep sleep 500
Clear

endif

endproc
WriteLib EditorLib Draw_Line


Style Attribute 192

@24,0 Clear EOL ?? "Compiling Copy_Area..."

proc closed copy_area()
Echo Normal
sysm = sysmode()
if sysm = "Script" or sysm = "Report" or sysm = "Form" then

   if isinsertmode() = true then
      @0,0 Clear EOL ?? "INSERT MODE ACTIVE ... TURN OFF ? y/n "
      Accept "A1" Picture "{Y,y,N,n}" required default "" to answer
          if answer = "Y" or answer = "y" then
             Ins
          endif
   endif


@0,0 Clear EOL ?? "Move to upper left hand corner of the area to COPY FROM and press [F6]"

r1 = 0
r2 = 0
c1 = 0
c2 = 0

editorit = 0

While (true)

gc = getchar()

Switch
     case gc = "Esc"     : Return

     case gc = asc("F1") :
                           Readlib editorpath+"EditHelp" HelpEdit HelpEdit()
                           gc = ""
                           Echo Normal
                           Right Left
                           loop

     case gc = asc("F6") and editorit = 0 :
                           r1 = rowno()
                           c1 = colno()
                           editorit = editorit + 1
                           @0,0 Clear EOL ?? "Move to lower right hand corner of the area to COPY FROM and press [F6]"
                           loop

     case gc = asc("F6") and editorit > 0 :
                           left
                           r2 = rowno()
                           c2 = colno()+1

     case gc = asc("Right") or gc = asc("Left") or gc = asc("CtrlRight") or gc = asc("CtrlLeft") :
                           keypress gc
                           loop

     case gc = asc("Up") or gc = asc("Down") or gc = asc("Home") or gc = asc("End") :
                           keypress gc
                           loop

     case gc = asc("CtrlHome") or gc = asc("CtrlEnd") :
                           keypress gc
                           loop

     case gc = asc("PgUp") or gc = asc("PgDn") :
                           keypress gc
                           loop


     OtherWise :Loop

     EndSwitch
     style attribute 192
     @0,0 Clear EOL ?? "One moment please..."
     echo off
     if r1 > 0 and r2 > 0 then
          getup = 0
         goback = 0
          width = abs(c1 - c2)
         length = abs(r1 - r2)

     Array Lin[length+1]


     for getup  from 1 to length step 1 up   endfor
     for goback from 1 to  width  step 1 left endfor

          Counter = 0

           direct = 0

     for counter from 1 to length+1 step 1
              start = c1
     if len(cursorline()) > 0 then
        if c1 = 1 then
           if len(cursorline()) = 1 then
               checklength = substr(cursorline(),c1,1) ;made the chg here
           else
               checklength = substr(cursorline(),c1,len(cursorline())-c1)
           endif
        else
           if len(cursorline()) < c1 then
              checklength = ""
           else
              checklength = substr(cursorline(),c1,len(cursorline())-c1)
           endif

        endif
     else
        checklength = ""
     endif

     stop = Min(len(cursorline())-c1+1,width+1)

     if len(cursorline()) = 0 then

         Lin[Counter]  = fill(" ",width)

     else

         if len(cursorline()) < c1 then
             Lin[Counter] = " "
         else
             Lin[Counter] = substr(cursorline(),c1,stop) ; change here
         endif

     endif
          While (true)
             pos = search("\"",lin[counter])
             if pos > 0 then
                   first = substr(lin[counter],1,pos-1)
                   last  = substr(lin[counter],pos+1,255)
                   lin[counter] = first+"\255"+last
                   loop
             endif
          quitloop
          EndWhile
          While (true)
             pos = search("\255",lin[counter])
             if pos > 0 then
                   first = substr(lin[counter],1,pos-1)
                   last  = substr(lin[counter],pos+1,255)
                   lin[counter] = first+"\\\""+last
                   loop
             endif
          quitloop
          EndWhile




     down

     endfor
     style
     quitloop
     endif

quitloop
endwhile

record=arraysize(lin)
varlin = ""

if isfile(privdir()+"copyit.sc") = true then
     run norefresh "erase "+privdir()+"copyit.sc"
     Right Left
endif
echo normal
print file privdir()+"copyit.sc" "Array Lin["+strval(record)+"]","\n"
print file privdir()+"copyit.sc" "length = ",length,"\n"
print file privdir()+"copyit.sc" "width = ",length,"\n"

for counter from 1 to record
        print file privdir()+"copyit.sc" "Lin["+strval(counter)+"]=","\"",Lin[Counter],"\"","\n"
endfor

else
     message "Cannot Copy in this environment"
endif



EndProc

writelib "editor3" copy_area


Style Attribute 192

@24,0 Clear EOL ?? "Compiling Paste_Area..."


Proc Closed Paste_Area()
UseVars EditorLib


Echo Normal
sysm = sysmode()
if sysm = "Script" or sysm = "Report" or sysm = "Form" then

   if isinsertmode() = true then
      @0,0 Clear EOL ?? "INSERT MODE ACTIVE ... TURN OFF ? y/n "
      Accept "A1" Picture "{Y,y,N,n}" required default "" to answer
          if answer = "Y" or answer = "y" then
             Ins
          endif
   endif


if isfile(privdir()+"copyit.sc") = false then
      message "nothing to copy"
      beep
      sleep 1000
      Return
endif

play privdir()+"copyit"


@0,0 Clear EOL ?? "Move to upper left hand corner of the area to COPY TO and press [F6]"

editorit = 0

While true
gc = getchar()
     if gc = asc("F1") then
          Readlib editorpath+"EditHelp" HelpEdit HelpEdit()
          gc = ""
          Echo Normal
          Right Left
          loop
     endif
     if gc = asc("F6") and editorit = 0 then
        r1 = rowno()
        c1 = colno()
        editorit = editorit + 1
     endif
     if gc = asc("Right") or gc = asc("Left") then
          keypress gc
          loop
     endif
     if gc = asc("CtrlHome") or gc = asc("CtrlEnd") then
           keypress gc
           loop
     endif
     if gc = asc("Home") or gc = asc("End") then
          keypress gc
          loop
     endif
     if gc = asc("CtrlRight") or gc = asc("CtrlLeft") then
          keypress gc
          loop
     endif
     if gc = asc("Up") or gc = asc("Down") then
          keypress gc
          loop
     endif
     if gc = asc("PgUp") or gc = asc("PgDn") then
          keypress gc
          loop
     endif

     if editorit > 0 then
     Style Attribute 192
     @0,0 Clear EOL ?? "One moment please..."
     Echo off
          getup = 0
         goback = 0

          Counter = 0

           direct = 0

     for counter from 1 to length+1 step 1

     typein lin[counter]

     for direct  from 1 to len(lin[counter]) step 1 left endfor

     down

     endfor

     endif
     style
     Echo Normal
quitloop
endwhile


else

Message "cannot copy in this enviroment" beep beep beep sleep 500
Clear

endif

echo off

endproc

writelib "editor3" paste_area


Style Attribute 192

@24,0 Clear EOL ?? "Compiling Select_Char()"


Proc Closed Select_Char()
UseVars editorpath
Private char

ShowMenu
         "Single" : "Draw with a Single Line",
         "Double" : "Draw using a Double Line",
         "Other"  : "Select an ASCII character",
         "Quit"   : "Return to the Main Menu"

          to char


Switch

case char = "Quit"   : Return


case char = "Single" :
                      xul = ""   xur = ""   xll = ""   xlr = ""
                      hchar = ""   con1 = "" con2 = "" con3 = ""
                      vchar = ""   con4 = "" con5 = ""

case char = "Double" :
                      xul = ""   xur = ""   xll = ""   xlr = ""  xfill = ""
                      hchar = ""  con1 = "" con2 = "" con3 = ""
                      vchar = ""  con4 = "" con5 = ""

case char = "Other"  :
                      @0,0 Clear EOL ?? "Which charcter "
                      Accept  "A8" Default "" required to char

                      xul = char  xur = char  xll = char  xlr = char xfill = char
                      hchar = char  con1 = char  con4 = char
                      vchar = char  con2 = char  con5 = char
                      ochar = char  con3 = char
OtherWise:loop

EndSwitch


Savevars xul,xur,xll,xlr,xfill,hchar,con1,con2,con3,vchar,con4,con5,char
RETURN
EndProc


writelib EditorLib Select_Char


Style Attribute 192

@24,0 Clear EOL ?? "Compiling Search_Replace..."


Proc Closed Search_Replace()
echo off

While (true)
findthis = ""
Replthis = ""
Style attribute 79
@0,0 Clear EOL
@1,0 Clear EOL
@0,0 ?? "Search for ?     "
Accept "A40"  Default findthis to FindThis

if retval = "Esc" then
     quitloop
endif
if findthis = "" then
     quitloop
endif
Style Attribute 48

@1,0 ?? "Replace with ?   "
Accept "A40"  Default ReplThis to ReplThis

if retval = "Esc" then
     quitloop
endif

checkthis = len(findthis) - len(replthis)

if search(findthis,replthis) > 0 then
      @0,0 Clear EOL ?? "Can't Recursively search"
      beep
      sleep 1000
      loop
endif

sysm = sysmode()
if sysm = "Script" or sysm = "Report" or sysm = "Form" then

   @24,0 Clear EOL ?? "Continue y/n ?"
   Accept "A1" picture "{Y,y,n,N}" required default "y" to answer

   @24,0 Clear EOL

   if answer = "n" or answer = "N" then
        quitloop
   endif


   if isinsertmode() = true then
      @0,0 Clear EOL ?? "INSERT MODE ACTIVE ... TURN OFF ? y/n "
      Accept "A1" Picture "{Y,y,N,n}" required default "" to answer
          if answer = "Y" or answer = "y" then
               Ins
          endif
   endif

   here = 0
counter = 0
repllen = 0
 begrow = 0
stoprow = 0
looklen = 0
   here = rowno()
foundit = 0
Home
begrow  = rowno()
End
stoprow = rowno()

Home
repllen = len(FindThis)

for counter from 1 to stoprow step 1
         While (true)
                lookatit = cursorline()
                pos = search(findthis,lookatit)
                if pos > 0 then
                      foundit = foundit+1
                      CtrlHome
                      for counter from 1 to pos-1
                           Right
                      endfor

                      keypress -82

                       for counter from 1 to repllen
                            keypress -83
                      endfor
                   typein replthis
                   keypress -82
                 loop
                 endif
          quitloop
          EndWhile
down
endfor

Style Intense
@2,0 Clear EOL
Style Reverse
@24,0 Clear EOL ?? Format("W50,AL","Number of succesful replaced strings = " + format("w4,EZ",foundit)) + " ... press any key"
gc = getchar()
style
Clear

CtrlHome

for counter from 1 to stoprow-1 step 1
up
endfor
else
message "Cannot edit in this enviroment"
beep
endif

quitloop
endwhile
echo normal
endproc

writelib "editor3" Search_Replace


Style Attribute 192

@24,0 Clear EOL ?? "Compiling Editor_Ref..."

Proc Closed Editor_Ref()
UseVars EditorLib

counter = 0
begin = counter+1
Array HLine[10]
stop = arraysize(HLine)

While (true)

linecounter = 0

if begin < 10 then begin = 1 endif

if begin > 235 then begin = 225 endif
if begin < 1 then begin = 1 endif

if begin = 1 then

for counter from begin to stop+begin-1
         linecounter = linecounter+1
         HLine[linecounter] = "  "+strval(asc(counter)) + " = " + chr(counter)+
                              "  "+strval(asc(counter+10)) + " = " + chr(counter+10)+
                              "  "+strval(asc(counter+20)) + " = " + chr(counter+20)
endfor

endif

if (begin > 1 and begin < 226) then

for counter from begin to (stop+begin-1)
         linecounter = linecounter+1
         HLine[linecounter] = "  "+strval(asc(counter)) + " = " + chr(counter)+
                              "  "+strval(asc(counter+10)) + " = " + chr(counter+10)+
                              "  "+strval(asc(counter+20)) + " = " + chr(counter+20)
endfor

endif


begin = counter


       line1  = HLine[1]
       line2  = HLine[2]
       line3  = HLine[3]
       line4  = HLine[4]
       line5  = HLine[5]
       line6  = HLine[6]
       line7  = HLine[7]
       line8  = HLine[8]
       line9  = HLine[9]
       line10 = HLine[10]


hfillchar = ""
vfillchar = ""
yul = ""  yur = ""
yll = ""  ylr = ""
wide = 30
tall = 5
upperx = 10
level = 1
if level <= 2 then
     uppery = 35
else
     uppery = 1
endif
topline = yul + fill(hfillchar,wide) + yur
fillline = vfillchar + spaces(wide) + vfillchar
bottomline = yll + fill(hfillchar,wide) + ylr
              @upperx,uppery ?? fillline

        for counter2 from 1 to tall step 1
              @upperx-counter2,uppery ?? topline

              for counter from 1 to counter2 step 1
                 @upperx+counter,uppery ?? fillline
              endfor
              @upperx+counter2,uppery ?? bottomline
              @upperx-counter2,uppery ?? fillline
        endfor

        @upperx-tall-1,uppery ?? topline
        @upperx-tall-1,uppery+2 ?? "ASCII Reference Chart"

textx = upperx-tall
texty = uppery+1

@textx+0,texty ?? Line1
@textx+1,texty ?? Line2
@textx+2,texty ?? Line3
@textx+3,texty ?? Line4
@textx+4,texty ?? Line5
@textx+5,texty ?? Line6
@textx+6,texty ?? Line7
@textx+7,texty ?? Line8
@textx+8,texty ?? Line9
@textx+9,texty ?? Line10
@textx+10,texty ?? "Press [PgUp] or [PgDn]"
gc = getchar()
style
Switch
case gc = -71   : begin = 1
                  loop
case gc = -79   : begin = 225
                  loop
case gc = -81   : loop

case gc = -73   : begin = begin-(2*stop)
                  loop

case gc = 13 or gc = 27        : Echo normal left right style quitloop


otherwise : begin=begin-stop loop

EndSwitch

quitloop
endwhile

cleanx = upperx - tall - 1
@cleanx,uppery Clear EOS

Release vars Textx,texty,HLine,gc,line1,line2,line3,line4,line5,
             line6,line7,line8,line9,line10,cleanx,upperx,tall,wide,more,set,
             topline,fillline,bottlomline,yul,yll,yur,ylr,
             counter
return
endproc


Style
@24,0 Clear EOL
Clear
writelib "Editor3" Editor_Ref


Style Attribute 192

@24,0 Clear EOL ?? "Compiling Editor_Help..."

Proc Closed Editor_Help(editorsel)
UseVars EditorLib
set = 1

While (true)

Readlib EditorLib Editor_text
        Editor_text(editorsel)

if isassigned(HLine[1]) = false then
     beep
     Style blink
     @0,0 Clear EOL ?? "Help not available..."
     beep
     sleep 1000
     style
     return
else
if set = 1 then
       line1  = HLine[1]
       line2  = HLine[2]
       line3  = HLine[3]
       line4  = HLine[4]
       line5  = HLine[5]
       line6  = HLine[6]
       line7  = HLine[7]
       line8  = HLine[8]
       line9  = HLine[9]
       line10 = HLine[10]
endif
if set = 2 then
       line1  = HLine[11]
       line2  = HLine[12]
       line3  = HLine[13]
       line4  = HLine[14]
       line5  = HLine[15]
       line6  = HLine[16]
       line7  = HLine[17]
       line8  = HLine[18]
       line9  = HLine[19]
       line10 = HLine[20]
endif


hfillchar = ""
vfillchar = ""
yul = ""  yur = ""
yll = ""  ylr = ""
wide = 30
tall = 5
upperx = 10
level = 1
if level <= 2 then
     uppery = 35
else
     uppery = 1
endif
topline = yul + fill(hfillchar,wide) + yur
fillline = vfillchar + spaces(wide) + vfillchar
bottomline = yll + fill(hfillchar,wide) + ylr
              @upperx,uppery ?? fillline

        for counter2 from 1 to tall step 1
              @upperx-counter2,uppery ?? topline

              for counter from 1 to counter2 step 1
                 @upperx+counter,uppery ?? fillline
              endfor
              @upperx+counter2,uppery ?? bottomline
              @upperx-counter2,uppery ?? fillline
        endfor

        @upperx-tall-1,uppery ?? topline


textx = upperx-tall
texty = uppery+1

@textx+0,texty ?? Line1
@textx+1,texty ?? Line2
@textx+2,texty ?? Line3
@textx+3,texty ?? Line4
@textx+4,texty ?? Line5
@textx+5,texty ?? Line6
@textx+6,texty ?? Line7
@textx+7,texty ?? Line8
@textx+8,texty ?? Line9
@textx+10,texty ?? Line10
endif
@upperx-tall-1,uppery+1 ?? editorsel
gc = getchar()
style
Switch


CASE gc = -81  and more = "Yes": set = 2
                                 loop
CASE gc = -73  and more = "Yes": set = 1
                                 loop

CASE gc = -81  and more = "No" : @24,0 Clear EOL ?? "No more help available ..."
                                 sleep 1000
                                 @24,0 Clear EOL
                                 loop

CASE gc = -73  and more = "No" : @24,0 Clear EOL ?? "No more help available ..."
                                 sleep 1000
                                 @24,0 Clear EOL
                                 loop

CASE gc = 13 or gc = 27        : Echo normal left right style quitloop


otherwise : loop

EndSwitch

quitloop
endwhile

cleanx = upperx - tall - 1
@cleanx,uppery Clear EOS

Release vars Textx,texty,HLine,gc,line1,line2,line3,line4,line5,
             line6,line7,line8,line9,line10,cleanx,upperx,tall,wide,more,set,
             topline,fillline,bottlomline,yul,yll,yur,ylr,
             counter
endproc


Style
@24,0 Clear EOL
Clear
writelib "Editor3" Editor_Help


Style Attribute 192

@24,0 Clear EOL ?? "Compiling Editor_Text..."

Proc Editor_Text(editorsel)

Array HLine[20]

While (true)


if editorsel = "Line" then
                   ;Help Text lines can be up to this wide
                   ;....+...10....+...20....+....
       HLine[1]  = "You may choose Single, Double"
       HLine[2]  = "or any other ASCII character "
       HLine[3]  = "by using [Alt] + 176 =  for "
       HLine[4]  = "example (see your PAL Users  "
       HLine[5]  = "Guide.                       "
       HLine[6]  = "                             "
       HLine[7]  = "Start Drawing by pressing    "
       HLine[8]  = "your arrow keys. Press your  "
       HLine[9]  = "[Enter] key  to stop.      "
       HLine[10] = " [PgDn]  ... more  = Quit  "
            more = "No"
endif
if editorsel = "Box" then
                   ;Help Text lines can be up to this wide
                   ;....+...10....+...20....+....
       HLine[1]  = "You may draw a box with      "
       HLine[2]  = "single, double or any other  "
       HLine[3]  = "ASCII character. (See your   "
       HLine[4]  = "PAL Users Guide)             "
       HLine[5]  = "                             "
       HLine[6]  = "Move to the upper left-hand  "
       HLine[7]  = "corner of where you wish to  "
       HLine[8]  = "start your box and press [F6]"
       HLine[9]  = "                             "
       HLine[10] = " [PgDn]  ... more  = Quit  "
            more = "Yes"
       HLine[11] = "Next move to the lower right-"
       HLine[12] = "hand corner of where you wish"
       HLine[13] = "your box to stop and press   "
       HLine[14] = "[F6] again.                  "
       HLine[15] = "                             "
       HLine[16] = "                             "
       HLine[17] = "                             "
       HLine[18] = "                             "
       HLine[19] = "                             "
       HLine[20] = " [PgUp]  ... more  = Quit  "
endif
if editorsel = "ASCII" then
                   ;Help Text lines can be up to this wide
                   ;....+...10....+...20....+....
       HLine[1]  = "Reference shows you several  "
       HLine[2]  = "the ASCII keys to typein     "
       HLine[3]  = "using MINISCRIPT or include  "
       HLine[4]  = "in your PAL statements.      "
       HLine[5]  = "                             "
       HLine[6]  = "For Example:                 "
       HLine[7]  = "                             "
       HLine[8]  = "            - = \\017\\196  "
       HLine[9]  = "                             "
       HLine[10] = "            = Quit         "
            more = "No"
endif

if editorsel = "Copy" then
                   ;Help Text lines can be up to this wide
                   ;....+...10....+...20....+....
       HLine[1]  = "Copy allows you to copy in a "
       HLine[2]  = "Script, Form or Report.      "
       HLine[3]  = "You can even copy screens    "
       HLine[4]  = "from your PAL scripts to your"
       HLine[5]  = "reports or from the headings "
       HLine[6]  = "from one report to another   "
       HLine[7]  = "table with a totally differ- "
       HLine[8]  = "nt structure.  First move to "
       HLine[9]  = "the upper left-hand ...      "
       HLine[10] = " [PgDn]  ... more  = Quit  "
            more = "Yes"
       HLine[11] = "... corner of the area you   "
       HLine[12] = "wish to copy and press [F6]. "
       HLine[13] = "Now move to the lower right- "
       HLine[14] = "hand corner of the area you  "
       HLine[15] = "wish to copy and press press "
       HLine[16] = "[F6] again. Finally, move to "
       HLine[17] = "the starting point of where  "
       HLine[18] = "you wish to copy to and press"
       HLine[19] = "[F6].                        "
       HLine[20] = " [PgUp]  ... more  = Quit  "
endif
if editorsel = "Replace" then
                   ;Help Text lines can be up to this wide
                   ;....+...10....+...20....+....
       HLine[1]  = "Replace allows you to find   "
       HLine[2]  = "a set of characters and      "
       HLine[3]  = "replace them with another    "
       HLine[4]  = "                             "
       HLine[5]  = "Warning--DO NOT REPLACE A SET"
       HLine[6]  = "AS FOLLOWS:                  "
       HLine[7]  = "  Search for: thisvar        "
       HLine[8]  = "Replace with: thisvarx       "
       HLine[9]  = "YOU'LL BE IN AN ENDLESS LOOP "
       HLine[10] = " [PgDn]  ... more  = Quit  "
            more = "Yes"
       HLine[11] = "Suggestion: Make two passes. "
       HLine[12] = "First replace 'thisvar' with "
       HLine[13] = "'xxxxx' then replace 'xxxxx' "
       HLine[14] = "with thisvarx.               "
       HLine[15] = "                             "
       HLine[16] = "                             "
       HLine[17] = "                             "
       HLine[18] = "                             "
       HLine[19] = "                             "
       HLine[20] = " [PgUp]  ... more  = Quit  "
endif
if editorsel = "File" then
                   ;Help Text lines can be up to this wide
                   ;....+...10....+...20....+....
       HLine[1]  = "File allows you to save a    "
       HLine[2]  = "script without exiting to the"
       HLine[3]  = "Paradox Main mode.  It can   "
       HLine[4]  = "also be used for a snapshot  "
       HLine[5]  = "of a FORM or REPORT.  (Use   "
       HLine[6]  = "print and choose FILE if you "
       HLine[7]  = "are trying to document a your"
       HLine[8]  = "system).                     "
       HLine[9]  = "                             "
       HLine[10] = "            = Quit          "
            more = "No"
endif
if editorsel = "Print" then
                   ;Help Text lines can be up to this wide
                   ;....+...10....+...20....+....
       HLine[1]  = "Print allows you to print the"
       HLine[2]  = "current SCRIPT,FORM or REPORT"
       HLine[3]  = "to the printer or to a file. "
       HLine[4]  = "                             "
       HLine[5]  = "You may choose to print with "
       HLine[6]  = "or without numbers.  This    "
       HLine[7]  = "scripts assumes that you have"
       HLine[8]  = "and IBM Proprinter or compat-"
       HLine[9]  = "ible.                        "
       HLine[10] = "            = Quit          "
            more = "No"
endif
if editorsel = "Special Keys" then
                   ;Help Text lines can be up to this wide
                   ;....+...10....+...20....+....
       HLine[1]  = "This selection allows you to "
       HLine[2]  = "place ASCII charracters below"
       HLine[3]  = "ASCII Code 32 on a FORM,     "
       HLine[4]  = "SCRIPT or REPORT.            "
       HLine[5]  = "                             "
       HLine[6]  = " Right =  Right Arrow =   "
       HLine[7]  = " Left  =  Left Arrow  =   "
       HLine[8]  = " Up    =  Down        =    "
       HLine[9]  = "                             "
       HLine[10] = "            = Quit         "
            more = "No"
endif

Return
EndWhile
endproc

Style
@24,0 Clear EOL
Clear
writelib "Editor3" Editor_Text


Style Attribute 192

@24,0 Clear EOL ?? "Compiling Print_it"


Proc Print_It()
scriptname = ""

While (true)
ShowMenu
         "Printer" : "Send Script to Printer",
         "File"    : "Send Script to a File"
          Until "F1"
          keyto keyvar
          to editorsel

          if keyvar = "F1" then
               helpsub = editorsel
               ReadLib EditorLib Editor_Help
                       Editor_Help(helpsub)
               loop
          endif

          Switch
case editorsel = "Esc"     : Return

case editorsel = "Printer" :
                            @0,0 Clear EOL ?? "Print Line Numbers ? "
                            Accept "a3" picture "{Yes,No}" required default "Yes" to numbans


                            While (true)
                                if printerstatus() = true then
                                     quitloop
                                else
                                     @24,0 Clear EOL "Printer Not Ready ..."
                                     loop
                                endif
                            EndWhile

                           sysm = sysmode()
                           if sysm = "Script" or sysm = "Report" or sysm = "Form" then


                                   Here = rowno()
                                   End
                                   stop = rowno()
                                   CtrlHome
                                   Home
                                   print "\015","\f"
                                   Style Attribute 192
                                   @0,0 Clear EOL ?? "Printing..."
                                   Style
                                   if numbans = "No" then

                                          for counter from 1 to stop
                                                print cursorline(),"\n"
                                                down
                                                if mod(counter,50) = 0 then
                                                     print "\f"
                                                endif
                                          endfor
                                                     print "\f"
                                          Home
                                          for counter from 1 to here
                                                down
                                          endfor

                                   else
                                          for counter from 1 to stop
                                                print strval(counter),")",cursorline(),"\n"
                                                down
                                                if mod(counter,50) = 0 then
                                                      print "\f"
                                                endif
                                          endfor
                                          Home
                                                     print "\f"
                                          for counter from 1 to here
                                                down
                                          endfor


                                   endif
                                 @0,0 Clear EOL
                           else

                                 message "Cannot work in this mode"
                                 beep
                                 sleep 1000
                           endif



case editorsel = "File"  :
                          @0,0 Clear EOL ?? "Print Line Numbers ? "
                          Accept "a3" picture "{Yes,No}" required default "Yes" to numbans

                          @0,0 Clear EOL ?? "Filename ? "
                          accept "a8" required to filename
                          if isassigned(filename) = false then
                                  Return
                          endif
                          if search(".",filename) > 0 then
                                    beep
                                    message "File Extension not allowed"
                                    sleep 1000
                                    return
                          endif
                          if isfile(filename+".sc") = true then
                                @24,0 Clear EOL ?? "File Exists / Replace File ?"
                                accept "a1" picture "{Y,N}" required to answer
                                if answer = "Y" then
                                     run NOREFRESH "erase "+filename+".sc"
                                else
                                     Return
                                endif
                          endif

                           sysm = sysmode()
                           if sysm = "Script" or sysm = "Report" or sysm = "Form" then


                                   Here = rowno()
                                   End
                                   stop = rowno()
                                   CtrlHome
                                   Home
                                   Style Attribute 192
                                   @0,0 Clear EOL ?? "Printing to file ",filename
                                   style
                                   if numbans = "No" then

                                          for counter from 1 to stop
                                                print file filename+".sc" cursorline(),"\n"
                                                down
                                          endfor
                                          Home
                                          for counter from 1 to here
                                                down
                                          endfor

                                   else
                                          for counter from 1 to stop
                                                print file filename+".sc" strval(counter),")",cursorline(),"\n"
                                                down
                                          endfor
                                          Home
                                          for counter from 1 to here
                                                down
                                          endfor


                                   endif
                                   @0,0 Clear EOL
                           else

                                 message "Cannot work in this mode"
                                 beep
                                 sleep 1000
                           endif




OtherWise:Loop
EndSwitch

Return
EndWhile

endproc

writelib EditorLib Print_It


Style Attribute 192

@24,0 Clear EOL ?? "Compiling Save_script..."

Proc Closed Save_Script ()
While (true)
@0,0 Clear EOL
@1,0 Clear EOL

@0,0 Clear EOL ?? "Script name = "
Accept "A8" required to scriptname

if isfile(scriptname+".sc") = true then
     @0,0 Clear EOL ?? "File exists ... [E]rase or [S]tart over ? "
      Accept "a1" picture "{S,s,E,e}" required default "S" to answer
     @0,0 Clear EOL
          if answer = "E" then
              run "erase " + scriptname + ".sc"

         else
              loop
         endif
endif

@0,0 Clear EOL ?? "Save this script as  " + scriptname + "  Yes/No ? "
Accept "a3" picture "{Yes,No}" required default "Yes" to answer
@0,0 Clear EOL ?? "Saving "
Style Blink ?? "..."
Style

if answer = "No" then
     quitloop
endif

Home
start = rowno()
end
stop  = rowno()
counter = 0
home
scriptname = scriptname + ".sc"
for counter from start to stop step 1
    print file scriptname  cursorline(),"\n"
    down
endfor
for counter from 1 to stop-1 step 1
up
endfor
@0,0 Clear EOL
quitloop
endwhile

endproc

writelib editorlib Save_Script


Style Attribute 192
@24,0 Clear EOL ?? "Compiling Editor_Menu..."

proc closed Special_Char()
usevars editorlib

while (true)

ShowMenu
               "Right" : "Place a right arrowhead ()",
                "Left" : "Place a left arrowhead ()",
                  "Up" : "Place a up arrowhead ()",
                "Down" : "Place a down arrowhead ()",
          "Left_Arrow" : "Place a left arrow ()",
         "Right_Arrow" : "Place a right arrow ()",
             "[ENTER]" : "Place an [ENTER] ()"

          Until "F1"
          keyto keyvar
          to editorsel

          if keyvar = "F1" then
               helpsub = "Special Keys"
               ReadLib EditorLib Editor_Help
                       Editor_Help(helpsub)
               loop
          endif

          Switch
                   case editorsel =         "Esc" : Return
                   case editorsel =       "Right" : typein ""
                   case editorsel =        "Left" : typein ""
                   case editorsel =          "Up" : typein ""
                   case editorsel =        "Down" : typein ""
                   case editorsel =  "Left_Arrow" : typein ""
                   case editorsel = "Right_Arrow" : typein ""
                   case editorsel =     "[ENTER]" : typein ""

          OtherWise:loop

          EndSwitch

quitloop
EndWhile
EndProc

writelib EditorLib Special_Char
