; NO_CUST

Reset
ClearAll

@0,0 Clear EOS

@24,0 Clear EOL ?? format("W75,AR","Looking for NEW Customers")
style blink ?? "..." style

While (true)

Query

 Sa_cust | Sa-Cust-No |
 set     | _a         |
         |            |

 Sa_dl |   Sa-Inv-Mo   | Sa-Mill-Code  |  Sa-Order-No  | Sa-Cust-No |
       | CheckGroupby  | CheckGroupby  | CheckGroupby  | _b,no _a   |
       |               |               |               | Check _b   |

 Sa_dl | Sa-Dest-Code  |  Sa-Prd-Code  |  Sa-Board-Ft  |  Sa-Mill-Amt  |
       | CheckGroupby  | CheckGroupby  | CheckGroupby  | CheckGroupby  |
       |               |               |               |               |

Endquery
Do_it!
Reset
ClearAll

if nrecords("answer") > 0 then

@24,0 Clear EOL ?? format("W75,AR","Adding NEW CUSTOMERS to the SA_CUST table")
style blink ?? "..." style


Query

 Sa_cust | Sa-Cust-No |
 insert  | _a         |

 Answer | Sa-Cust-No |
        | _a         |

Endquery
Do_it!
Reset
ClearAll

Autolib = "ProcLibr"
While (true)

View "Sa_Cust"
CoEditKey
PickForm "1"
Scan for isblank([sa-cust-name])

        While (true)
        Wait Record
        Prompt "ENTER THE CUSTOMER NAME ...                     F2   ",
               " Continue"
        Until "F2","Ins","Del"
        lookretval = retval
        if lookretval = "F2" then
              if isblank([sa-cust-name]) = true then
                    beep
                    @24,0 Clear EOL ?? format("AR,W75","CUSTOMER NAME REQUIRED TO CONTINUE") style blink ?? "..." style
                    beep sleep 1000
                    loop
              endif
        endif
        if lookretval = "Ins" then
                    @24,0 Clear EOL ?? format("AR,W75","INSERT IS NOT ALLOWED IN THIS PROCEDURE") style blink ?? "..." style
                    beep sleep 1000
                    loop
        endif
        if lookretval = "Del" then
                    @24,0 Clear EOL ?? "Delete this record ? "
                    Accept "A1" picture "{Y,N}" required default "N" to answer
                    if answer = "Y" then
                            keypress -83
                    endif
                    loop
        endif
        quitloop
        EndWhile
EndScan
Do_it!

quitloop
EndWhile


Reset
ClearAll
else

@24,0 Clear EOL ?? format("AR,W75","No NEW customers ") style blink ?? "..." style
beep
sleep 1000
endif


quitloop
EndWhile
