; Ssedit01.sc

PROC GetDept()
 PRIVATE dept
  CLEAR
  dept = ""
  @ 5,0 ?? "Enter department to edit, press RETURN (\17\217) for lookup table: "
  STYLE REVERSE
  ACCEPT "A10" PICTURE "*!" TO dept
  STYLE
  IF retval = False THEN
    RETURN False
  ELSE
    IF ISBLANK(dept) THEN
      MOVETO "Dept"
      WHILE True
        WAIT TABLE
          PROMPT "Move cursor to Department to select",
                 "[F2]-Select    [Esc]-Cancel"
          UNTIL "F2","Esc","DOS","DOSBIG","ZOOM","ZOOMNEXT"
        SWITCH
          CASE retval = "F2"  : dept = [Department]  QUITLOOP
          CASE retval = "Esc" : dept = False         QUITLOOP
          OTHERWISE           : BEEP
        ENDSWITCH
      ENDWHILE
    ENDIF
  ENDIF
  RETURN dept
ENDPROC



PROC EditEmpByDept()                       ; Ssedit01.sc
 PRIVATE dept,anyrcdflag
;
; Private variables:
;   dept       - department to edit
;   anyrcdflag - flag to indicate if any records where found in scan
;
  VIEW "Dept"
  dept = GetDept()                          ;  Get name of department to edit
  CLEAR
  IF dept = False THEN                      ;  If no department selected
    MESSAGE "No department selected"
    SLEEP 3000
  ELSE
    MESSAGE "Selecting employees in ",dept," department, please wait"
    COEDIT "Employee"
    PICKFORM 1
    anyrcdflag = 1
    SCAN FOR [Department] = dept
      anyrcdflag = 0                        ;  Set flag to indicate at least
      WHILE True                            ; one record exists
        WAIT RECORD
          PROMPT "Edit record    [F2]-Save/Exit    [F3]-Next Table   " +
                 "[PgDn]-Next Record"
          UNTIL "F3","PgDn","F2","DOS","DOSBIG","ZOOM","ZOOMNEXT"
        SWITCH
          CASE retval = "F3"    : DOWNIMAGE LOOP
          CASE retval = "PgDn"  :
               SWITCH
                 CASE TABLE() = "Employee" : QUITLOOP
                 CASE TABLE() = "Benefits" : BEEP LOOP
                 CASE TABLE() = "Depndnts" : SKIP 1 LOOP
               ENDSWITCH
          CASE retval = "F2"    : QUITLOOP
          OTHERWISE             : BEEP
        ENDSWITCH
      ENDWHILE
      IF retval = "F2" THEN
        QUITLOOP
      ENDIF
    ENDSCAN
    IF anyrcdflag = 1 THEN                  ;  If not records matched dept
      MESSAGE "No employees in ",dept," department"
    ELSE
      MESSAGE "Editing complete"
    ENDIF
    SLEEP 3000
    DO_IT!
  ENDIF
ENDPROC

RELEASE VARS ALL
RESET
EditEmpByDept()
CLEARALL
