; Ssedit02.sc


PROC GetDept()
 PRIVATE dept
  CLEAR
  dept = ""
  @ 5,0 ?? "Enter department to edit, press RETURN (\17\217) for lookup table: "
  STYLE REVERSE
  ACCEPT "A10" PICTURE "*!" TO dept
  STYLE
  IF retval = False THEN
    RETURN False
  ELSE
    IF ISBLANK(dept) THEN
      MOVETO "Dept"
      WHILE True
        WAIT TABLE
          PROMPT "Move cursor to Department to select",
                 "[F2]-Select    [Esc]-Cancel"
          UNTIL "F2","Esc","DOS","DOSBIG","ZOOM","ZOOMNEXT"
        SWITCH
          CASE retval = "F2"  : dept = [Department]  QUITLOOP
          CASE retval = "Esc" : dept = False         QUITLOOP
          OTHERWISE           : BEEP
        ENDSWITCH
      ENDWHILE
    ENDIF
  ENDIF
  RETURN dept
ENDPROC


PROC GetSubset()                            ; Ssedit01.sc
  {Ask} {Employee} CHECK [Department] = dept
  DO_IT!
  IF ISEMPTY("Answer") THEN
    RETURN False
  ELSE
    RETURN True
  ENDIF
ENDPROC


PROC EditEmpByDept()                       ; Ssedit02.sc
 PRIVATE dept
;
; Private variables:
;   dept       - department to edit
;
  VIEW "Dept"
  dept = GetDept()                          ;  Get name of department to edit
  CLEAR
  IF dept = False THEN                      ;  If no department selected
    MESSAGE "No department selected"
    SLEEP 3000
  ELSE
    MESSAGE "Selecting employees in ",dept," department, please wait"
    CANVAS OFF
    retprocval = GetSubset()                ;  Select data to edit
    IF retprocval = False THEN              ;  No records for dept
      CANVAS ON
      MESSAGE "No employees in ",dept," department"
      SLEEP 3000
      RETURN
    ENDIF
    COPYFORM "Employee" "1" "Answer" "1"
    COEDIT "Answer"
    PICKFORM 1
    msg = ""
    CANVAS ON
    WHILE True
      WAIT RECORD
        PROMPT "Edit record    [F2]-Save/Exit    [F3]-Next Table",
               "[PgDn]-Next Record   [PgUp]-Previous Record"
        MESSAGE msg
        UNTIL "F3","PgDn","PgUp","F2","DOS","DOSBIG","ZOOM","ZOOMNEXT"
      msg = ""
      SWITCH
        CASE retval = "F3"   :
             DOWNIMAGE
             LOOP
        CASE retval = "PgDn" :
             SWITCH
               CASE TABLE() = "Answer"   :  ;  Employee  records are in Answer
                    SKIP                    ;  Move to next record.  If
                    IF EOT() THEN           ; this is the last record
                      BEEP                  ; notify the user.
                      msg = "No more " + dept + " records!"
                    ENDIF
                    LOOP
               CASE TABLE() = "Benefits" :
                    BEEP
                    LOOP
               CASE TABLE() = "Depndnts" :
                    SKIP
                    LOOP
             ENDSWITCH
        CASE retval = "PgUp" :
             SWITCH
               CASE TABLE() = "Answer"   :
                    SKIP -1                 ;  Move to next record.  If
                    IF BOT() THEN           ; this is the last record
                      BEEP                  ; notify the user.
                      msg = "This is the first " + dept + " record!"
                    ENDIF
                    LOOP
               CASE TABLE() = "Benefits" :
                    BEEP
                    LOOP
               CASE TABLE() = "Depndnts" :
                    SKIP
                    LOOP
             ENDSWITCH
        CASE retval = "F2"   :  QUITLOOP
        OTHERWISE            :  BEEP
      ENDSWITCH
    ENDWHILE
    MESSAGE "Editing complete"
    SLEEP 3000
    DO_IT!
  ENDIF
ENDPROC

RELEASE VARS ALL
RESET
EditEmpByDept()
CLEARALL
