;************************************************
;*** TestCal1                                 ***
;***                                          ***
;***                                          ***
;*** G.Salcedo 8/25/90                        ***
;************************************************
;
;Tests the various forms of producing summary
;queries.  Prints to a file TCRes_1.sc"
;
While (true)
@0,0 Clear EOS

;
;
;

Release Vars All
Release Procs All
Reset ClearAll

if isfile("tcres_1.sc") = true then
     Menu {Tools} {Delete} {Script} {tcres_1} {OK}
endif

;
;
;

LibName = "QueryLb1"
AutoLib = LibName
infolib(libname)

;
;
;
;

Array TestProc[nrecords("list")]

moveto[procedure]

@0,0 Clear EOL ?? "Working "

Scan
                  element = [#]
        TestProc[element] = []
       ?? "."
EndScan
?? "Script=TestCal1"
;
;
;
;

stoptest = arraysize(testproc)

;
;
;
;

for counter from 1 to stoptest step 1
reset
       membefore = " MStart="+strval(memleft())

       ProcName = testproc[counter]

       @1,0 Clear EOL ?? "Executing ",procname," ",counter," of ",stoptest
       style blink ?? "..."
       style

       Starttime = " Start="+time()

       execproc procname

       EndTime = " End="+time()

       memafter = " MEnd="+strval(memleft())

       RecordResult = Procname+"\t"+StartTime+"\t"+EndTime+
                      "\t"+membefore+"\t"+memafter

       print file "tcres_1.sc" RecordResult,"\n"
       release vars membefore,procname,starttime,endtime,memafter,recordresult
endfor
quitloop
EndWhile
