;************************************************
;*** TestCal3                                 ***
;***                                          ***
;***                                          ***
;*** G.Salcedo 8/25/90                        ***
;************************************************
;
;Tests the various forms of producing summary
;queries.  Prints to a file TCRes_3.sc"
;
While (true)
@0,0 Clear EOS
;
;
;

Release Vars All
Release Procs All
Reset ClearAll

if isfile("tcres_3.sc") = true then
     Menu {Tools} {Delete} {Script} {tcres_3} {OK}
endif

;
;
;

LibName = "QueryLb2,Time"
AutoLib = LibName
infolib("QueryLb2")

;
;
;
;

Array TestProc[nrecords("list")]

moveto[procedure]

@0,0 Clear EOL ?? "Working "

Scan
                  element = [#]
        TestProc[element] = []
       ?? "."
EndScan
?? "Script=TestCal3"
;
;
;
;

stoptest = arraysize(testproc)

;
;
;
;

for counter from 1 to stoptest step 1
reset clearall

       membefore = " MStart="+strval(memleft())

       ProcName = testproc[counter]

       @1,0 Clear EOL ?? "Executing ",procname," ",counter," of ",stoptest
       style blink ?? "..."
       style
       D=today()
       SW=time()
       Stime = CalcTime(D,SW)
       Starttime = " Start="+SW

       execproc procname

       D=today()
       SW=time()
       ETime =  CalcTime(D,SW)
       Endtime = " End="+SW
       memafter = " MEnd="+strval(memleft())
       Interval =ETime-STime
       Trans_int(Interval)
       Elapsed = "Elapsed="+ret_interval

       RecordResult = Procname+"\t"+StartTime+"\t"+EndTime+
                      "\t"+membefore+"\t"+memafter+"\t"+Elapsed

       print file "tcres_3.sc" RecordResult,"\n"
       release vars membefore,procname,starttime,endtime,memafter,recordresult
       release vars elapsed,S,SW,Interval
       release procs CalcTime,Trans_int
endfor
quitloop
EndWhile
