;************************************************
;*** TestCalC                                 ***
;***                                          ***
;***                                          ***
;*** G.Salcedo 8/25/90                        ***
;************************************************
;
;Tests the various forms of producing summary
;queries.  Prints to a file TCResult.sc"
;
While (true)
@0,0 Clear EOS

;
;
;

Release Vars All
Release Procs All
Reset ClearAll

if isfile("tcresult.sc") = true then
     Menu {Tools} {Delete} {Script} {tcresult} {OK}
endif

;
;
;

Menu {Tools} {Info} {Inventory} {Files} {10*.sc}

;
;
;
;

Array TestScript[nrecords("list")]

moveto[name]

@0,0 Clear EOL ?? "Working "

Scan
                  element = [#]
        TestScript[element] = substr([],1,search(".",[])-1)
       ?? "."
EndScan
?? "Script=TestCalc"
;
;
;
;

stoptest = arraysize(testscript)

;
;
;
;

for counter from 1 to stoptest step 1
reset clearall
       membefore = " MStart="+strval(memleft())

       ScriptName = testscript[counter]

       @1,0 Clear EOL ?? "Executing ",ScriptName," ",counter," of ",stoptest
       style blink ?? "..."
       style

       Starttime = " Start="+time()

       play scriptname

       EndTime = " End="+time()

       memafter = " MEnd="+strval(memleft())

       RecordResult = ScriptName+"\t"+StartTime+"\t"+EndTime+
                      "\t"+membefore+"\t"+memafter

       print file "tcresult.sc" RecordResult,"\n"
       release vars membefore,procname,starttime,endtime,memafter,recordresult
endfor
quitloop
EndWhile
