; student editing script

VIEW "grades"
CoEdit "student"

msg.text = ""
WHILE true
   CtrlHome Right     ; move to first field in table view
   FirstShow
   ImageRights READONLY
   WAIT TABLE
      PROMPT FORMAT("AL,W6",UserName())+"          F9: Edit student info    ;    Ins: Add new student",
      "                Esc: Leave               ;    Del: Delete student"
      MESSAGE msg.text
   UNTIL "F9","Ins","Del","Esc","Lockkey"
   ImageRights
   msg.text = ""
   SWITCH
      CASE RETVAL = "F9" :
         LockRecord
         IF RETVAL = false THEN
            BEEP
            msg.text = "Record is in use by "+UserName()
         ELSE
            PICKFORM "1"
            ImageRights UPDATE
            WAIT RECORD
               PROMPT "Make changes, Press F2 when done"
            UNTIL "F2"
            UnLockRecord
            FormKey           ; back to table view
         ENDIF
         
      CASE RETVAL = "Ins" :
         Ins
         PICKFORM "1"
         MOVETO FIELD "STUDENT ID"
         msg.text = ""
         WHILE true
            WAIT FIELD
               PROMPT "Enter new ID, then press Enter",
               "Press Esc to return"
               MESSAGE msg.text
            UNTIL "Enter","Esc","LockKey"
            msg.text = ""
            IF RETVAL = "Enter" AND NOT IsBlank([]) THEN
               LockRecord
               IF RETVAL = false THEN
                  BEEP
                  [] = []  ; assign the key field to itself, leave KeyViol mode
                  msg.text = "That ID is already in use - use another"
                  LOOP
               ENDIF
               ImageRights UPDATE
               Enter   ; execute the Enter operation, bring user to 2nd field
               WAIT RECORD
                  PROMPT "Add complete record, Press F2 when done"
               UNTIL "F2"
               [LINK STUDENT ID] = [STUDENT ID] ; assign the "dummy" field
               LockRecord    ; post the record to the table, then lock it
               UnLockRecord  ; unlock the record
            ELSE; Esc was pressed, or ID was not filled in
               DEL    ; un-insert the record - "close up the row"
            ENDIF
            FormKey    ; back to table view
            QUITLOOP
         ENDWHILE
         
      CASE RETVAL = "Del" :
         LockRecord ; lock the record in preparation to delete it
         IF RETVAL = false THEN
            BEEP
            msg.text = "Record is in use by "+UserName()
            UnLockRecord
         ELSE
            student.id = [STUDENT ID]
            MOVETO "GRADES" ; moveto detail table (it's in TableView)
            MOVETO FIELD "STUDENT ID"
            LOCATE student.id     ; see if there are any detail records
            MOVETO "STUDENT" ; move back to table being edited
            IF RETVAL = true THEN
               BEEP
               msg.text = "Cannot delete student record - GRADES still exist"
               UnLockRecord
            ELSE
               SHOWMENU
               "Oops!":"Do not delete the record",
               "Delete":"Delete the record"
               TO delete.ok
               IF delete.ok = "Delete" THEN
                  DEL
                  msg.text = "Record deleted - Press Ctrl-U to get it back"
               ELSE; user did not want to delete
                  UnLockRecord
               ENDIF
            ENDIF
         ENDIF
         
      CASE RETVAL = "Esc" :
         QUITLOOP
   ENDSWITCH
ENDWHILE
Do_It!
ClearAll

RELEASE VARS msg.txt, delete.ok, student.id

