; Login.sc

;  This script contains a generic logon procedure

PROC Login()
 PRIVATE chngconnect
  IF NOT ISSQL() THEN
    RETURN True
  ELSE
    IF NOT ISBLANK(SQLCONNECTINFO("TITLE")) THEN      ;  If current connection
                                                      ; connection active
      @ 24,0 ?? "Current connection: ",SQLCONNECTINFO("Title")+ ". Change it" +
                " (Y/N)? "
      STYLE REVERSE
      ACCEPT "A1" PICTURE "{Y,N}" DEFAULT "N" TO chngconnect
      STYLE
      @ 24,0 CLEAR EOL
      IF chngconnect = "Y" THEN
        SQLSELECTCONNECT
        IF retval THEN
           SQLSAVECONNECT
           RETURN False
        ELSE
          @ 24,0 ?? "Connection not made, press any key to continue"
          kp = GETCHAR()
          @ 24,0 CLEAR EOL
          RETURN True
        ENDIF
      ELSE
        RETURN False
      ENDIF
    ELSE
      MESSAGE "Loading connection screen, Please wait!"
      SQLSELECTCONNECT
      IF retval THEN
         SQLSAVECONNECT
         RETURN False
      ELSE
        @ 24,0 ?? "Connection not made, press any key to continue"
        kp = GETCHAR()
        @ 24,0 CLEAR EOL
        RETURN True
      ENDIF

    ENDIF
  ENDIF
ENDPROC

Login()
IF retval = True THEN
  CLEAR
  @ 5,0
  ? "Connection to server failed: "
  ? "SQLERRORCODE    : ",SQLERRORCODE()
  ? "SQLERRORMESSAGE : ",SQLERRORMESSAGE()
  @ 24,0 ?? "Press any key to continue"
  kp = GETCHAR()
 ELSE
  MESSAGE "Connection made"
ENDIF
