;**************************************************************************
;Script [EditAcct]
;Description [Edit or enter information based on the CUSTOMER table linked
;             to the ACCOUNTS table (1-M)                                ]
;Created [05/26/90] By [G.Salcedo ]
;**************************************************************************

While (true)

CoEdit TableName
Menu {Image} {Pickform} select pform
IMAGERIGHTS Update

While (true)  ; Keep doing UNTIL


Wait Table
Prompt "Press [F2] Save ...   [F5] LookUp CUSTOMER #...  [F6] LookUp Last Name"+sysmode(),
       "Press [F7] Add New Cust#      [F9] Calc Total ... [F10] Other Function"
Until  "F2", -108, "Del", "DOS","DOSBIG","F10","F3","F4","F9","F5","F6","Ins"
lookretval = retval

if lookretval = "DOS" or lookretval = "DOSBIG" then
       NoDosExit("Top")
       loop
endif

if lookretval = "F3" or lookretval = "F4" then
       keypress lookretval
       loop
endif

if lookretval = "F5" then
      @1,0 Clear EOL
      @0,0 Clear EOL ?? "Customer # ? "
      accept "n" to answer
      if isassigned(answer) = false then
            loop
      endif
      if answer = "Esc" then
            loop
      endif
      moveto 1
      moveto field "customer number"
      ZOOM select answer
      loop
endif
if lookretval = "F6" then
      @1,0 Clear EOL
      @0,0 Clear EOL ?? "Last Name ? "
      accept "a35" to answer
      if isassigned(answer) = false then
            loop
      endif
      if answer = "Esc" then
            loop
      endif
      moveto 1
      moveto field "Last Name"
      ZOOM select answer+".."
      loop
endif

if lookretval = -108 then
      keypress -108
      While (true)
      WAIT FIELD
      Prompt "Press [F2] or [ENTER] to leave FIELDVIEW"
      UNTIL "F2","Enter","DOS","DOSBIG"
      fieldretval = retval
      if fieldretval = "DOS" or fieldretval = "DOSBIG" then
           NoDosExit("Bottom")
           loop
      endif
      if fieldretval = "F2" or fieldretval = "Enter" then
           quitloop
      endif
      EndWhile
      release vars fieldretval
      loop
endif

if lookretval = "Del" then
        @24,0 Clear EOL ?? "Do you really want to delete (Y/N) ? "
        Accept "A1" picture "{Y,N}" default "N" to answer
        if answer = "Y" then
              Del
              loop
        else
              loop
        endif
endif

if lookretval = "Ins" then
     IMAGERIGHTS
     keypress -82
     While (true)

     newnumber = round(rand()*100000,-2) ;assign arbitrary number

     [customer number] = newnumber
     if errorcode() = 53 then
           beep
           [customer number]=[customer number]
           loop
     endif


     quitloop
     EndWhile
     IMAGERIGHTS Update
     loop
endif

if lookretval = "F9" then
      FFlag = isformview()
      if FFlag = false then
      FormKey
      endif
      here = imageno()
      here2 = field()
      moveto 1
      Lockrecord
      moveto 2

      stop = nimagerecords()
      MessgBox(97)
      for counter from 1 to stop
            if [product/service code] < 10000 then
               if isblank([quantity]) = true then
                      MessgBox(3)
                      quitloop
               else
                   [line total] = [quantity]*[amount]
               endif
            endif
      endfor

      moveto field "line total"
      total = imagecsum()
      moveto 1
      moveto field "current balance"
      [] = total
      moveto here
      moveto field here2
      UNLOCKRECORD
      if FFlag = false then
          FormKey
      endif
      loop
endif

if lookretval = "F10" then
      @0,0 Clear EOL ?? format("AC,W79","No OTHER functions available")
      beep sleep 1000
      loop
endif

if lookretval = "F2" then
     Do_it!
endif

Reset
ClearAll
ReDrawPopBox(level)
Release procs ReDrawPopBox
reset

quitloop
Endwhile

quitloop
Endwhile

