;**************************************************************************
;Script [EntrInv ]
;Description [Enter and print a new invoice
;
;Created [05/26/90] By [G.Salcedo ]
;**************************************************************************
Reset
ClearAll
ShowMenu
         "Existing":"Create INVOICE for an existing customer",
         "New"     :"Create NEW CUSTOMER and INVOICE"
         Until "F2" keyto keyvar
         to sel
         Switch
                   case sel = "Esc"      : ReDrawPopBox(level) Return
                   case sel = "Existing" : ; Select from existing
                   case sel = "New"      : ; New customer
         OtherWise:Loop
         EndSwitch

MessgBox(97) ; one moment please

if sel = "Existing" then
       play "Sel_Cust"
endif

counter = 0

if sel = "New" then

While (true)
LOCK "CUSTOMER" PFL

if retval = false then
    loop
endif

View "Customer"
moveto field "customer number"

quitloop
EndWhile

MessgBox(97)
counter = counter+1

While (true)

     newnumber = round(rand()*100000,-2) ;assign arbitrary cust#

     locate newnumber

     if retval = false then
          Reset
          quitloop
     endif

EndWhile

endif

Reset
play "invnumb"

pform = "2"
IMAGERIGHTS
if sel = "Existing" then
       CoEdit shadow+"\\custmstr"
       Menu {Image} {PickForm} select pform
       COPYFROMARRAY TRANCUST
       IMAGERIGHTS UPDATE
       moveto 3
       [invoice number] = newnumber
else
       CoEdit shadow+"\\custmstr"
       Menu {Image} {PickForm} select pform
       [customer number] = newnumber
       IMAGERIGHTS UPDATE
       moveto 3
       [invoice number] = newnumber
       moveto 2
endif


While (true)
goback = ""
FIRSTSHOW
MessgBox(97)

While (true)  ; Keep doing UNTIL

     Wait Table
     Prompt "Press [F2] Save...  [F3] Change Customer Info    "+sysmode(),
            "[F4] Change Invoice Information   [F9] Calc Item and Total ... "
     Until  "F2", -108, "Del", "DOS","DOSBIG","F3","F4","F9"

lookretval = retval

if lookretval = "DOS" or lookretval = "DOSBIG" then
       NoDosExit("Top")
       loop
endif

if lookretval = "F3" then
     moveto 2
     loop
endif

if lookretval = "F4" then
     moveto 3
     loop
endif

if lookretval = -108 then ;FieldView
      keypress -108
      While (true)
      WAIT FIELD
      Prompt "Press [F2] or [ENTER] to leave FIELDVIEW"
      UNTIL "F2","Enter","DOS","DOSBIG"
      fieldretval = retval
      if fieldretval = "DOS" or fieldretval = "DOSBIG" then
           NoDosExit("Bottom")
           loop
      endif
      if fieldretval = "F2" or fieldretval = "Enter" then
           quitloop
      endif
      EndWhile
      release vars fieldretval
      loop
endif
if lookretval = "Del" then
        @24,0 Clear EOL ?? "Do you really want to delete (Y/N) ? "
        Accept "A1" picture "{Y,N}" default "N" to answer
        if answer = "Y" then
              Del
              loop
        else
              loop
        endif
endif
if lookretval = "F9" then
      if imageno() <> 3 then
           moveto 3
      endif
      COPYTOARRAY INVREC
      FFlag = isformview()
      if FFlag = false then
      FormKey
      endif
      here = imageno()
      here2 = field()
      here3 = recno()
      moveto 2
      [invoice balance] = 0
      moveto 3

      stop = nimagerecords()
      MessgBox(97)
      Scan
;      for counter from 1 to stop
            if [product/service code] < 10000 then
                 if isblank([quantity]) = true then
                      MessgBox(3)
                      quitloop
                 endif
                 [line total] = [quantity]*[amount]
                 [debit/credit] = "D"
            else
                 [line total] = [amount]*-1
                 [debit/credit] = "C"
            endif
            if [line total] > 0 then
                    [debit/credit] = "D"
            else
                    [debit/credit] = "C"
            endif

  ;    endfor
      EndScan
      moveto field "line total"
      down up
      total = imagecsum()
      moveto 2
      moveto field "invoice balance"
      [] = total
      moveto here
      moveto field here2
      home up
      moveto record here3
      CtrlHome
      Down
      INVREC[5] = blanknum()
      INVREC[6] = ""
      INVREC[7] = blanknum()
      INVREC[8] = blanknum()
      INVREC[9] = ""
      INVREC[10] = ""
      INVREC[11] = blanknum()
      COPYFROMARRAY INVREC
      if FFlag = false then
          FormKey
      endif
      loop
endif

; Before you leave this routine by selecting "F2" all records are
; calculated and assigned debit/credit flags.  If a quantity field is
; blank for an inventory item, the routine sends you back to the top
; and prompts you to enter the quantity.

if lookretval = "F2" then
     Do_it!
     if nrecords(shadow+"\\invoice") > 0 then

     CoEdit shadow+"\\invoice"
     MessgBox(97)
     Scan

                 if [product/service code] > 9999 then
                      [line total] = [amount]*-1
                      [debit/credit] = "C"
                 else
                      if isblank([quantity]) = false then

                           [line total] = [quantity]*[amount]
                           [debit/credit] = "D"
                      else
                           if isblank([product/service code]) = true then
                                Del
                           else
                                here3 = recno()
                                goback = "Yes"
                           endif
                      endif
                endif
     EndScan
     Do_it!
     if goback = "Yes" then
            goback = ""
            MessgBox(3)
            moveto 2
            FormKey
            moveto 3
            moveto record here3
            moveto field "quantity"
            CoEditKey
            loop
     endif
     endif
counter = 0
printit = ""

;In this section you put the information back in the the CUSTOMER
;and ACCOUNTS tables.

While (true)
MessgBox(97)

counter = counter+1

LOCK "ACCOUNTS" PFL

if retval = true then
     ADD  shadow+"\\invoice" "ACCOUNTS"
else
    if counter < 20 then
          beep
          loop
    else
          MessgBox(91)
          printit = "No"
    endif
endif

UNLOCK "ACCOUNTS" PFL

quitloop
EndWhile
if sel <> "Existing" then
While (true)
MessgBox(97)
counter = counter+1

LOCK "CUSTOMER" PFL

if retval = true then
     ADD shadow+"\\custmstr" "Customer"

else
    if counter < 10 then
          loop
    else
          MessgBox(91)
          printit = "No"
          message printit
          gc = getchar()
    endif
endif

UNLOCK "CUSTOMER" PFL
Reset
quitloop
EndWhile
endif

endif

While (true)

PROMPT

if nrecords(shadow+"\\invoice") > 0 and printit <> "No" then

     ShowMenu
              "Print":"Print out the Invoices",
              "Skip" :"Don't print the invoices now"
              to answer
              switch
                    case answer = "Print" : play "prntnewi"
                    case answer = "Skip"  : empty shadow+"\\custmstr"
                                            empty shadow+"\\invoice"
                                            quitloop
              OtherWise:loop
              EndSwitch
else
      quitloop
endif

quitloop
EndWhile

Reset
ClearAll
ReDrawPopBox(level)
Release procs ReDrawPopBox
reset

quitloop
Endwhile

quitloop
Endwhile

