;**************************************************************************
;Script:MMain
;Description:Main Menu for the ABC Music Store
;
;Created [9/15/90] By [G.Salcedo ]
;**************************************************************************
AutoLib = "MMenus,MMesgLib,MMenuHlp"
Color = 31
shadow = privdir()+"shadow"
play "preptabl"

setkey "F11" play "MMain"

While (true)
CANVAS OFF
Release Procs All
Release Vars All
Reset
Clear
ClearAll
shadow = privdir()+"shadow"
Autolib = "MMenus,MMesgLib,MMenuHlp"

Array  Prevx[4]
Array  Prevy[4]
Array PrevNC[4]
Array PrevPW[4]
Array PrevCL[4]
Array  PrevN[4]
Array PrevML[4]

Level = 1                        ; Set Menu level to 1
    n = 1                        ; Set first menu choice

 Prevx[Level] = 3                ; Upper Left 'X' coordinate
 Prevy[Level] = 25               ; Upper Left 'Y' coordinate
PrevNC[Level] = 6                ; Number of menu choices
PrevPW[Level] = 20               ; Width of the PopUp Menu
PrevCL[Level] = 31               ; Color of the Menu
PrevML[Level] = "  Main Menu    "; Menu Name

       BeginX = Prevx[Level]
       BeginY = Prevy[Level]
NumberChoices = PrevNC[Level]
     Popwidth = PrevPW[Level]
        Color = PrevCL[level]
     MenuName = PrevML[level]



; the following arrays set up all the menu choices and their
; corresponding messages
;
;        C[n] = menu items (the possible choices)
;        D[n] = descriptions of the menu items
;       SC[n] = "top bar" representation of menu item
;       SD[n] = "top bar"      "         "   "     "  description
;     NICK[n] = first letter of menu items

Array         C[NumberChoices]
Array         D[NumberChoices]
Array        SC[NumberChoices]
Array        SD[NumberChoices]
Array      NICK[NumberChoices]

; These are the menu choices and the corresponding "wide" bar (top) display.
; Be sure to enclose the menu item in quotes. The number of characters in the
; menu items should not exceed the PopWidth-2. Example "View".

C[1] = "Administration"
D[1] = "Invoice, Print Statements and other functions"

C[2] = "Student"
D[2] = "Go the the MUSIC lesson menu"

C[3] = "Inventory"
D[3] = "Go to the Inventory Menu"

C[4] = "Utilities"
D[4] = "Go to the Utilities Menu"

C[5] = "Info"
D[5] = "More information on system"

C[6] = "Quit"
D[6] = "Exit the System"


if isassigned(n) = false then
     n = 1
else
     n = n
endif

last = arraysize(c)

CANVAS ON

FillMenu()

SelMenu()
Reset

if sel = "Esc" then
     @24,0 Clear EOL ?? format("w79,ac","One moment please ...")
     quitloop

else


switch
           case sel = "Esc" : level = level -1
                              quitloop
           case sel = c[1]  : play "Modimenu"
           case sel = c[2]  : play "lesnmenu"
           case sel = c[3]  : play "invtmenu"
           case sel = c[4]  : play "utilmenu"
           case sel = c[5]  : HelpMenu(sel)
           case sel = c[6]  : play "chekdata"
                              if dataexists = "Yes" then
                                   MessgBox(100)
                                   loop
                              endif
                              quitloop

OtherWise:loop

EndSwitch

endif

EndWhile

