;**************************************************************************
;Script:MMenuHlp
;Description: Messages for the MENU HELP facility
;
;Created [5/26/90 ] By [G.Salcedo ]
;**************************************************************************

@24,0 Clear EOL ?? "Compiling MMenuHlp "
Style Blink ?? "..."
Style

createlib "MMenuHlp"

Proc Closed HelpMenu(Sel)
Usevars Color
CURSOR OFF
CANVAS OFF
@19,10 Clear EOS

PaintCanvas FILL "" Attribute 113
20,12,24,68

Style Attribute Color
@19,10 ?? "ͻ"
@20,10 ?? "                                                        "
@21,10 ?? "                                                        "
@22,10 ?? "                                                        "
@23,10 ?? "ͼ"
CANVAS ON
                   ;....+...10....+...20....+....30....+...40....+...50....+.
if sel = "Customer" then
         HLine1  = "SELECT Customer browse thru the CUSTOMER table"
         HLine2  = "SUGGESTION: for editing select ACCOUNTS"
         HLine3  = ""
endif
if sel = "Administration" then
         HLine1  = "This choice allows you to go the View/Modify Menu"
         HLine2  = "You may View or Edit any file in the current"
         HLine3  = "directory."
endif
if sel = "Students" then
         HLine1  = "                                                        "
         HLine2  = "    View the STUDENT table of information               "
         HLine3  = "                                                        "
endif
if sel = "Reports" then
         HLine1  = ""
         HLine2  = "  Produce Statements, Aging and Product Reports"
         HLine3  = ""
endif

if sel = "Utilities" then
         HLine1  = "          BACKUP, Recovery, System Utilities            "
         HLine2  = "                 RUN OTHER PROGRAMS                     "
         HLine3  = "                 EXPORT/IMPORT data                     "
endif
if sel = "Info" then
         HLine1  = "This is an example system that demonstrates some of  "
         HLine2  = "Paradox's capabilities.  You should look at this as a"
         HLine3  = "guide and not a completely ready to run application. "
endif
if sel = "Products" then
         HLine1  = ""
         HLine2  = "  View the PRODUCTS table"
         HLine3  = ""
endif
if sel = "Administration" then
         HLine1  = "   Allows you to perform initial and batch entries of"
         HLine2  = "   data.                                             "
         HLine3  = "                                                     "
endif
if sel = "Invoice" then
         HLine1  = "                                                     "
         HLine2  = "              Create an Invoice                      "
         HLine3  = "                                                     "
endif
if sel = "Print"     then
         HLine1  = "                                                     "
         HLine2  = "              Print Class Schedule                   "
         HLine3  = "                                                     "
endif
if sel = "Statements" then
         HLine1  = "                                                     "
         HLine2  = "            Print Statements                         "
         HLine3  = "                                                     "
endif
if sel = "More" then
         HLine1  = ""
         HLine2  = "    More SELECTIONS"
         HLine3  = ""
endif
if sel = "Student" then
         HLine1  = ""
         HLine2  = "        Go to the MUSIC Lesson Menu"
         HLine3  = ""
endif
if sel = "Forecast" then
         HLine1  = ""
         HLine2  = "               Add dates to the Class Schedule"
         HLine3  = ""
endif
if sel = "Aging" then
         HLine1  = ""
         HLine2  = "          Produces a current aging"
         HLine3  = ""
endif
if sel = "Backup" then
         HLine1  = ""
         HLine2  = "        BACKUP a SINGLE or all FILES to DISK"
         HLine3  = ""
endif
if sel = "Date/Time" then
         HLine1  = "                   EXIT to DOS"
         HLine2  = "         RESET the SYSTEM Date and/or Time"
         HLine3  = ""
endif
if sel = "System/Analysis" then
         HLine1  = ""
         HLine2  = "    Run Statitics on the SYSTEM to evaluate Performance"
         HLine3  = ""
endif
if sel = "Quit" then
         HLine1  = ""
         HLine2  = "    Select this to GO BACK to the Previous Menu or to"
         HLine3  = "                 QUIT the SYSTEM                     "
endif

if isassigned(Hline1) = false and isassigned(Hline2) = false and
   isassigned(Hline3) = false then
        HLine1 = ""
        HLine2 = "                   HELP NOT AVAILABLE"
        HLine3 = ""
endif
style attribute color
@20,12 ?? format("W54,AL",HLine1)
@21,12 ?? format("W54,AL",HLine2)
@22,12 ?? format("W54,AL",HLine3)
style

gc = getchar()

@19,0 Clear EOS

CURSOR NORMAL
endproc

writelib "MMenuHlp" HelpMenu
