While (true)

begdate = today()-day(today())

style
@24,0 Clear EOL ?? "Print STATEMENTS thru  ",begdate "  ?  "
Style Reverse
Accept "D" required default begdate to begdate
Style

if isassigned(begdate) = false then
     @24,0 Clear EOL
     quitloop
endif
if retval = "Esc" then
     @24,0 Clear EOL
     quitloop
endif


prevdate = begdate-60                   ;add C0 here
prevdate = prevdate-day(prevdate)+1

nr = nrecords("accounts")
Reset
CURSOR OFF
@24,0 Clear EOL ?? "SCANNING for MISSING Debit/Credit FLAGS"
style blink ?? "..." style
CoEdit "Accounts"
moveto[DR/CR]
Scan
      if isblank([]) = true then
          if [charge/credit] >= 0 then
                  [] = "D"
          else
                  [] = "C"
          endif
      endif

       here = int(([#]/nr) * 100)
       if mod(here,5) = 0 then
           @24,65 ??  here," % complete"
       endif
EndScan
Do_it!
CURSOR NORMAL
Reset
ClearAll

@24,0 Clear EOL ?? "Getting ACCOUNT information " style blink ?? "..." style

menu {ask} {accounts}
CheckPlus
moveto[date]
typein "<="
typein begdate
moveto[notes]
CheckPlus
Do_it!

rename "answer" "stmt"

{Modify} {Restructure} {Stmt} CtrlEnd
"*" Down  "*" Down  "*" Down "*"
Do_it!


Reset
ClearAll

;;;;;;;;;;;add C1 here
Query

 Stmt | CUSTOMER # |    DATE    |          CHARGE/CREDIT          |
      | Check      | <~prevdate | calc sum all as "CHARGE/CREDIT" |
      |            |            |                                 |
      |            |            |                                 |

Endquery
Do_it!              ;add
RENAME "ANSWER" "T1";
Reset
ClearAll


;;;;;;;;add c2 here
Query

  Stmt  | CUSTOMER # |  CODE  | DR/CR | CHARGE/CREDIT |
 insert | _c         | "PREV" | "D"   | _tot          |
        |            |        |       |               |
        |            |        |       |               |

 T1 | CUSTOMER # | CHARGE/CREDIT |
    | _c         | >=0,_tot      |
    |            |               |
    |            |               |

Endquery
Do_it! ;add
Reset
ClearAll


;;;;;;;add c3 here

Query

  Stmt  | CUSTOMER # |  CODE  | DR/CR | CHARGE/CREDIT |
 insert | _c         | "PREV" | "C"   | _tot          |
        |            |        |       |               |
        |            |        |       |               |

 T1 | CUSTOMER # | CHARGE/CREDIT |
    | _c         | <0,_tot       |
    |            |               |
    |            |               |

Endquery
Do_it! ;add
reset
clearall


;;;;;;;;;add c4
Query

  Stmt  |         DATE         |
 delete | not blank,<~prevdate |
        |                      |
        |                      |

Endquery
Do_it!;add
Reset
ClearAll


@24,0 Clear EOL ?? "Summing ACCOUNT information " style blink ?? "..." style
Menu {ask} {Stmt}
moveto[customer #]
Check
moveto[charge/credit]
typein "calc sum as total"
Do_it!

Reset ClearAll
@24,0 Clear EOL ?? "Finding ZERO accounts " style blink ?? "..." style
Menu {ask} {answer}
typein "delete"
moveto[total]
typein "0 or >-.01,<.01"
Do_it!

rename "deleted" "ZEROBAL"
Reset ClearAll

@24,0 Clear EOL ?? "CREATING CROSSTAB" style blink ?? "..." style
View "stmt"
moveto[reference no]
CrossTabKey
@24,0 Clear EOL ?? "COPYING REPORT information " style blink ?? "..." style
rename "crosstab" "sdetail"
CopyReport "StmtDetl" "1" "Sdetail" "1"

@24,0 Clear EOL ?? "Deleting ZERO accounts " style blink ?? "..." style
menu {ask} {ZEROBAL}
moveto[customer #]
Example "cust"

menu {ask} {sdetail}
typein "delete"
moveto[customer #]
Example "cust"
Do_it!

@24,0 Clear EOL ?? "Clearing ZERO's from ACCOUNT information " style blink ?? "..." style
Reset Clearall
menu {ask} {sdetail}
moveto[d]
typein "0,changeto blank"
Do_it!
menu {ask} {sdetail}
Del
moveto[c]
typein "0,changeto blank"
Do_it!
reset clearall
quit


;;;;c5

Query

 Sdetail | CODE |   D   |   C   |
 delete  | PREV | blank | blank |
         |      |       |       |
         |      |       |       |

Endquery
Do_it!
Reset
ClearAll


@0,0 Clear EOL ?? "Checking PRINTER" style blink ?? "..." style
While (true)
        MessgBox(97)
        Style
        @24,0 Clear EOL
        if printerstatus() = false then
            Style Attribute 192
            @0,0 Clear EOL ?? "Printer Not Ready ..."
            ShowMenu
                     "Quit" : "Stop printing process",
                     "Retry": "Try printer again"
                      to answer
                      Switch
                            case answer = "Quit"  : ClearMsg()
                                                    @0,0 Clear EOL
                                                    quitloop
                            case answer = "Retry" : loop
                      OtherWise:Loop
                      EndSwitch
        endif
        @0,0 Clear EOL
        Style
        @0,0 Clear EOL ?? "PRINTING STATEMENTS" style blink ?? "..." style
        ClearMsg()
        MessgBox(97)

        REPORT "SDetail" "1"

Reset
ClearAll

quitloop
EndWhile


@0,0 Clear EOL
Reset
ClearAll

quitloop
EndWhile
