;**************************************************************************
;Script [ViewCust]
;Description [Edit or enter information based on the CUSTOMER table linked
;             to the ACCOUNTS table (1-M)                                ]
;Created [05/26/90] By [G.Salcedo ]
;**************************************************************************

MessgBox(97)

ShowMenu
        "Update Total" : "Update the customer totals",
        "Go"           : "View the Customer table without updating the totals"
        Until "F2" keyto keyvar
        to answer
                 Switch
                        case answer = "Update Total":    play "UpdtTotl"
                        case answer = "Go" :
                 OtherWise:loop
                 EndSwitch

While (true)
        Lock "Customer" PFL
        if retval = true then
              quitloop
        endif
EndWhile



While (true)


View tablename
Pickform pform

While (true)  ; Keep doing UNTIL


Wait Table
Prompt "Press [F2] Save ...   [F5] LookUp CUSTOMER #...  [F6] LookUp Last Name  "+sysmode(),
       "Press [F7] Form Toggle ....                      [F10] Edit Record"
Until  "F2", "F7" ,-108, "Del", "DOS","DOSBIG","F10","F3","F4","F5","F6"
lookretval = retval

if lookretval = "DOS" or lookretval = "DOSBIG" then
       NoDosExit("Top")
       loop
endif

if lookretval = "F3" or lookretval = "F4" then
       keypress lookretval
       loop
endif

if lookretval = "F5" then
      @1,0 Clear EOL
      @0,0 Clear EOL ?? "Customer # ? "
      accept "n" to answer
      if isassigned(answer) = false then
            loop
      endif
      if answer = "Esc" then
            loop
      endif
      moveto field "customer number"
      ZOOM select answer
      loop
endif
if lookretval = "F6" then
      @1,0 Clear EOL
      @0,0 Clear EOL ?? "Last Name ? "
      accept "a35" to answer
      if isassigned(answer) = false then
            loop
      endif
      if answer = "Esc" then
            loop
      endif
      moveto field "Last Name"
      ZOOM select answer
      loop
endif

if lookretval = -108 then
      keypress -108
      While (true)
      WAIT FIELD
      Prompt "Press [F2] or [ENTER] to leave FIELDVIEW"
      UNTIL "F2","Enter","DOS","DOSBIG"
      fieldretval = retval
      if fieldretval = "DOS" or fieldretval = "DOSBIG" then
           NoDosExit("Bottom")
           loop
      endif
      if fieldretval = "F2" or fieldretval = "Enter" then
           quitloop
      endif
      EndWhile
      release vars fieldretval
      loop
endif


if lookretval = "F7" then
     Formkey
     loop
endif

if lookretval = "F10" then
      CoEditKey
      Wait Record
      Prompt "Make Changes ... press [F2] to continue"
      Until "F2","Esc"
      if retval = "F2" then
           Do_it!
      else
           UNDO
           Do_it!
      endif
      loop
endif
UNLOCK "CUSTOMER" FL
Reset
ClearAll
ReDrawPopBox(level)
Release procs ReDrawPopBox
reset

quitloop
Endwhile

quitloop
Endwhile

