;ͻ
; Script Name: DBSelect   Creation Date: 4/06/88      Author: M. Rudy       
;                         Last Revision: 8/02/90  Revised By: M. Rudy       
;Ķ
; Description: This script displays a Paradox menu to select a database       
;              (alias directory) to make the working directory.               
;                                                                             
;                                                                             
;                                                                             
;Ķ
; Called By: NONE                                                             
;Ķ
; Libraries: NONE                                                             
;Ķ
; Tables    Forms    Reports  Scripts   Procedures         External Pgms 
;Ķ
; NONE      NONE     NONE     NONE      NONE               NONE          
;                                                                        
;                                                                        
;                                                                        
;Ķ
;Notes: NONE                                                                  
;                                                                             
;ͼ


RESET                                       ;  Put Paradox in Main Mode
STYLE REVERSE
@ 5,0 ?? FORMAT("w80,ac","Database Selection Menu - Main Title Screen")
STYLE
@ 7,10  ?? "The current directory is: " + DIRECTORY()

SHOWMENU
  "Scripts"              : "Special scripts directory",
  "Dvlpment"             : "Special scripts being development",
  "Company"              : "Company sample application",
  "Finance"              : "Finance application",
  "ToDoList"             : "Personal TO DO Lists",
  "Wishlist"             : "Paradox wish list",
  "ActItems"             : "Action item database",
  "Status"               : "Status system database",
  "Demo"                 : "Database used to do demos",
  "Info"                 : "General Information",
  "Gantt"                : "Gantt chart example - in work",
  "Receivables/Payables" : "Account payable and receivables",
  "Budgets"              : "Current year budget database"
TO choice
IF choice = "Esc" THEN
  RETURN
ENDIF

SWITCH
 CASE choice = "Company"              : SETDIR "D:\\Pdxappl\\Company"
 CASE choice = "Gantt"                : SETDIR "D:\\Pdxappl\\Gantt"
 CASE choice = "Wishlist"             : SETDIR "D:\\Pdxappl\\Wishlist"
 CASE choice = "Receivables/Payables" : SETDIR "C:\\Pdxdata\\RecPay"
 OTHERWISE                            : SETDIR "C:\\Pdxdata\\" + choice
ENDSWITCH
CLEAR
RELEASE VARS choice
QUIT  "Directory is now: " + DIRECTORY()
